'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 22 November 2001 at 11:40:18 pm'!
Object subclass: #VWXMLAttributeDef
	instanceVariableNames: 'name default type flags '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLAttributeDef commentStamp: '<historical>' prior: 0!
XML documents may contain attribute-list declarations that are used to define the set of attributes pertaining to a given element type. These attribute-list declarations are also used to establish type constraints for the attributes and to provide default values for attributes. VWXMLAttribute-list declarations contain attribute definitions and this class is used to instantiate these attribute definitions.

An attribute definition specifies the name (name instance variable) of the attribute, the data type of the attribute (type instance variable) and an optional default value (default instance variable) for the attribute

Instance Variables:
	name	<VWXMLNodeTag> 		name of attribute
	default	<Object>  				default value, if any
	type	<VWXMLAttributeType>	type used for validation
	flags	<Integer>				encoding for fixed, implied and required type attributes
!

VWXMLAttributeDef class
	instanceVariableNames: ''!
Object subclass: #VWXMLAttributeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLAttributeType commentStamp: '<historical>' prior: 0!
This class with its various subclasses represents the type of the XML attribute. According to the XML 1.0 specification, XML attribute types are of three kinds:a string type, a set of tokenized types, and enumerated types. The string type may take any literal string as a value, the tokenized types have varying lexical and semantic constraints and the enumerated type attibutes can take one of a list of values provided in the declaration.

Subclasses of VWXMLAttributeType represent these various types of XML attributes !

VWXMLAttributeType class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLCDATAat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLCDATAat commentStamp: '<historical>' prior: 0!
This class represents the CDATA attribute type. A CDATA attribute is used to escape blocks of text containing characters which would otherwise be recognized as markup.

CDATA sections are demilited by the start-tag '<!![CDATA[' and the end-tag ']]'.!

VWXMLCDATAat class
	instanceVariableNames: ''!
Object subclass: #VWXMLDocumentType
	instanceVariableNames: 'attributeDefs elementDefs generalEntities parameterEntities notations '
	classVariableNames: 'PredefinedEntities '
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLDocumentType commentStamp: '<historical>' prior: 0!
This class represents an XML document type definition or DTD. The document type declaration can point to an external subset containing markup declarations, or can contain the markup declarations directly in an internal subset, or can do both. The DTD for a document consists of both subsets taken together.

Instance Variables:
	attributeDefs	<Dictionary>
	elementDefs	<Dictionary>
	generalEntities	<Dictionary>
	parameterEntities	<Dictionary>
	notations	<Dictionary>
!

VWXMLDocumentType class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLENTITIESat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLENTITIESat commentStamp: '<historical>' prior: 0!
This class represents the ENTITIES attribute type. This is a tokenized type of attribute that signifies to the XML parser that for the purposes of validating, the values of entities type attributes must match each of the names of unparsed entities declared in the document type definition.!

VWXMLENTITIESat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLENTITYat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLENTITYat commentStamp: '<historical>' prior: 0!
This class represents the ENTITY attribute type. This is a tokenized type of attribute that signifies to the XML parser that for the purposes of validating, the values of entity type attributes must match the name of an unparsed entity declared in the document type definition.!

VWXMLENTITYat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLENUMERATIONat
	instanceVariableNames: 'values '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLENUMERATIONat commentStamp: '<historical>' prior: 0!
This class represents the Enumeration attribute type. Enumerated attributes can take one of a list of values provided in the declaration.

Instance Variables:
	values	<Collection>
!

VWXMLENUMERATIONat class
	instanceVariableNames: ''!
Object subclass: #VWXMLElementContext
	instanceVariableNames: 'tag namespaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLElementContext commentStamp: '<historical>' prior: 0!
This class includes some functionality to support XML namespaces. XML namespaces provide a simple method for qualifying element and attribute names used in XML documents 

Instance Variables:
	tag	<VWXMLNodeTag>
	namespaces	<Dictionary>
!

VWXMLElementContext class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLIDREFSat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLIDREFSat commentStamp: '<historical>' prior: 0!
This class represents the IDREFS attribute type. This is a tokenized type of attribute and for an XML document to be valid, each of the values of IDREFS type attributes must match each of the values of some ID attribute on some element in the XML document.!

VWXMLIDREFSat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLIDREFat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLIDREFat commentStamp: '<historical>' prior: 0!
This class represents the IDREF attribute type. This is a tokenized type of attribute and for an XML document to be valid, values of IDREF type attributes must match the value of some ID attribute on some element in the XML document.

ID and IDREF attributes together provide a simple inside-the-document linking mechanism with every IDREF attribute required to point to an ID attribute as stated above.!

VWXMLIDREFat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLIDat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLIDat commentStamp: '<historical>' prior: 0!
This class represents the ID attribute type. This is also a tokenized type of attribute and values of ID type attributes must match legal names as defined in the XML 1.0 specification. 

For an XML document to be valid, ID values must uniquely identify the elements which bear them; i.e. A name must not appear more than once in an XML document as a value of this type. Also for validity purposes, an ID attribute must have a declared default of #IMPLIED or #REQUIRED in the DTD.

ID and IDREF attributes together provide a simple inside-the-document linking mechanism with every IDREF attribute required to point to an ID attribute.!

VWXMLIDat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLNMTOKENSat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLNMTOKENSat commentStamp: '<historical>' prior: 0!
This class represents the NMTOKENS attribute type. This is a tokenized type of attribute and for the purposes of validation, values of each NMTOKENS type attributes must match each Nmtoken, which is any mixture of legal name characters as defined in the XML 1.0 specification. !

VWXMLNMTOKENSat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLNMTOKENat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLNMTOKENat commentStamp: '<historical>' prior: 0!
This class represents the NMTOKEN attribute type. This is a tokenized type of attribute and for the purposes of validation, values of NMTOKEN type attributes must match a Nmtoken, which is any mixture of legal name characters as defined in the XML 1.0 specification. !

VWXMLNMTOKENat class
	instanceVariableNames: ''!
VWXMLAttributeType subclass: #VWXMLNOTATIONat
	instanceVariableNames: 'typeNames '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Attributes'!

!VWXMLNOTATIONat commentStamp: '<historical>' prior: 0!
This class represents the NOTATION attribute type. A NOTATION attribute identifies a notation element, declared in the DTD with associated system and/or public identifiers, to be used in interpreting the element to which the attribute is attached.

Instance Variables:
	typeNames	<SequenceableCollection>
!

VWXMLNOTATIONat class
	instanceVariableNames: ''!
Object subclass: #VWXMLNode
	instanceVariableNames: 'parent flags '
	classVariableNames: ''
	poolDictionaries: 'XML '
	category: 'XML-Nodes'!

!VWXMLNode commentStamp: '<historical>' prior: 0!
An VWXMLNode represents a logical component of an XML VWXMLDocument. Logically, the
document is composed of declarations, elements, comments, character references, and 
processing instructions, all of which are indicated in the document by explicit markup. 
The various subclasses of VWXMLNode represent these various components.

Subclasses must implement the following messages:
	printing
		printCanonicalOn:
		printHTMLOn:
		printNoIndentOn:endSpacing:spacing:

Instance Variables:
	parent	<VWXMLNode | nil> 
	flags	<SmallInteger> 
!

VWXMLNode subclass: #VWXMLAttribute
	instanceVariableNames: 'name value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLAttribute commentStamp: '<historical>' prior: 0!
XML elements may have name-value pairs called attributes associated with them. This class instantiates an XML attribute.

Instance Variables:
	name	<VWXMLNode | VWXMLNodeTag>	tag name
	value	<Object>					tag value
!

VWXMLNode subclass: #VWXMLComment
	instanceVariableNames: 'text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLComment commentStamp: '<historical>' prior: 0!
This class represents an XML comment. XML comments may appear anywhere in an XML document outside other markup or within the document type declaration at places allowed by grammar.

 XML comments are delimited by the start-tag '<!!--' and the end-tag '-->'. 

According to the XML 1.0 specification, for compatibilty, double-hyphens (the string '--') must not occur within comments.

Instance Variables:
	text	<String>  contents of the comment element
!

VWXMLNode subclass: #VWXMLDocument
	instanceVariableNames: 'root nodes xmlVersion dtd ids '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLDocument commentStamp: '<historical>' prior: 0!
This class represents an XML document entity and serves as the root of the document entity tree. Each XML document has one entity (root) called the document entity, which serves as the starting point for the XML processor and may contain the whole document (nodes collection). 

According to the XML 1.0 specification, XML documents may and should begin with an XML declaration which specifies the version of XML (xmlVersion instance variable) being used. 

The XML document type declaration which must appear before the first element in a document contains or points to markup declarations that provide the grammar for this document. This grammar is known as document type definition (dtd instance variable). An XML document is valid if it has an associated document type declaration and if the document complies with the constraints expressed in it

Instance Variables:
	root	<VWXMLNode>  
	nodes	<Collection>  
	xmlVersion	<String>  
		Version of the XML specification to which the document is conformant
	dtd	<VWXMLDocumentType>
		Associated document type definition 
	ids	<KeyedCollection | Dictionary>  
!

VWXMLNode subclass: #VWXMLElement
	instanceVariableNames: 'tag attributes namespaces elements definition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLElement commentStamp: '<historical>' prior: 0!
XML document element boundaries are either delimited by start-tags and end-tags, or, for empty elements, by an empty-element tag. Each element has a type, identified by name, sometimes called its "generic identifier" (GI), and may have a set of attribute specifications. Each attribute specification has a name and a value.

Instance Variables:
	tag				<String | VWXMLNodeTag>  the tag name of this element
	attributes		<Collection>  comment
	namespaces	<Dictionary>  comment
	elements		<SequenceableCollection>  comment
	definition		<Object>  suspect this is unused
!

VWXMLNode subclass: #VWXMLEntity
	instanceVariableNames: 'name text systemID publicID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLEntity commentStamp: '<historical>' prior: 0!
An XML document may consist of one or many storage units called entities. All XML entities have content and are idententified by name. 

Entities may be either parsed or unparsed. This class and it's subclasses VWXMLGeneralEntity and VWXMLParameterEntity represent parsed entities. These entities are invoked by name using entity references and their contents are held in the text instance variable

Entities may also be internal or external. If the content of the entity is given in the declaration (within the document) itself then the entity is called an internal entity. If the entity is not internal to the document and is declared elsewhere it's called an external entity. 

External entities have a system identifier (systemID instance variable) that is an URI which may be used to retrieve the entity. In addition to a system identifier, an external entity declaration may include a public identifier (publicID instance variable). The VWXMLXMLParser uses the publicID to try to generate an alternative URI to retrive the entity's contents.

Subclasses must implement the following messages:
	accessing
		entityType

Instance Variables:
	name	<VWXMLNodeTag>  
				Identifies the entity in an entity referece
	text	<SequenceableCollection | Filename | IOAccessor | ExternalConnection | LogicalFilename | EncodedStreamConstructor>
				The entity's contents
	systemID	<VWXMLURIResolver>
				URI used to retrieve an external entity's contents
	publicID	<VWXMLURIResolver>
				Alternative URI used to retrieve an external entity's contents
!

VWXMLEntity subclass: #VWXMLGeneralEntity
	instanceVariableNames: 'ndata '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLGeneralEntity commentStamp: '<historical>' prior: 0!
This class represents a general entity which is a parsed entity for use within the XML document content.

Instance Variables:
	ndata	<VWXMLNotation>
!

VWXMLNode class
	instanceVariableNames: ''!
VWXMLAttribute class
	instanceVariableNames: ''!
VWXMLComment class
	instanceVariableNames: ''!
VWXMLDocument class
	instanceVariableNames: ''!
VWXMLElement class
	instanceVariableNames: ''!
VWXMLEntity class
	instanceVariableNames: ''!
VWXMLGeneralEntity class
	instanceVariableNames: ''!
Magnitude subclass: #VWXMLNodeTag
	instanceVariableNames: 'namespace type qualifier '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLNodeTag commentStamp: '<historical>' prior: 0!
In XML all elements or nodes are delimited by start and end tags (or empty-element tags) and instances of this class are used to represent these element tags. The name of the tag (type instance variable) gives the element type.


Instance Variables:
	namespace	<String>
	type	<String> Name of tag, used to indicate element type
	qualifier	<String>
!

VWXMLNodeTag class
	instanceVariableNames: ''!
VWXMLNode subclass: #VWXMLNotation
	instanceVariableNames: 'name publicID systemID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLNotation commentStamp: '<historical>' prior: 0!
This class represents an XML VWXMLNotation declaration. Notations are XML elements/nodes which identify by name the format of unparsed entities, the format of elements which bear a notation
attribute or the application to which a processing instruction is addressed.

Notations are delimited by the start-tag '<!!NOTATION' and end-tag '>'

The name instance variable provides a name or identifier for the notation, for use in entity and
attribute specifications. The publicID instance variable provides an external identifier which allows
the XML processor or the client application to locate a helper application capable of processing
data in the given notation. The systemID variable allows the parser to optionally resolve the
publicID into the system identifier, file name, or other information needed to allow the application to call a processor for data in the notation.


Instance Variables:
	name	<VWXMLNodeTag>
	publicID	<VWXMLURIResolver>
	systemID	<VWXMLURIResolver>
!

VWXMLNotation class
	instanceVariableNames: ''!
VWXMLNode subclass: #VWXMLPI
	instanceVariableNames: 'name text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLPI commentStamp: '<historical>' prior: 0!
This class represents the XML Processing Instruction element. Processing instructions allow XML documents to contain instructions for applications.  XML processing instructions are delimited by the start-tag '<?' and the end-tag '?>'. According to the XML 1.0 specification, the target names "XML", "xml" and so on are reserved for standardization

Instance Variables:
	name	<VWXMLNodeTag>	the target of this processing instruction, used to identify the application to which this processing instruction is directed.
	text		<String>			the processing instructions themselves!

VWXMLPI class
	instanceVariableNames: ''!
VWXMLEntity subclass: #VWXMLParameterEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLParameterEntity commentStamp: '<historical>' prior: 0!
This class represents a parameter entity which is a parsed entity for use within the document type definition. !

VWXMLParameterEntity class
	instanceVariableNames: ''!
Object subclass: #VWXMLPattern
	instanceVariableNames: 'followSet '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLPattern commentStamp: '<historical>' prior: 0!
The element structure of an XML document may, for validation purposes, be constrained using element type and attribute-list declarations. An element type declaration constrains the element's content by constraining which element types can appear as children of the element.The constraint includes a content model, a simple grammar or pattern governing the allowed types of child elements and the order in which they are allowed to appear. These content models are represented by this VWXMLPattern class and it's subclasses.

Constraint rules or patterns maybe complex (VWXMLComplexPattern and it's subclasses) or simple (VWXMLConcretePattern and it's subclasses).
 
Subclasses must implement the following messages:
	coercing
		alternateHeads
		pushDownFollowSet
	testing
		isSimple

Instance Variables:
	followSet	<MethodFilterOr | MethodFilterAnd | Collection>  comment
!

VWXMLPattern subclass: #VWXMLComplexPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLComplexPattern commentStamp: '<historical>' prior: 0!
This class is the superclass to what are considered 'complex' patterns or rules in the element content declarations. As seen from the class hiererarchy, instances of complex patterns include VWXMLChoicePattern, VWXMLMixedPattern, VWXMLModifiedPattern and VWXMLSequencePattern.!

VWXMLComplexPattern subclass: #VWXMLChoicePattern
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLChoicePattern commentStamp: '<historical>' prior: 0!
This class represents the 'choice' element content constraint in an element type declaration. According to the XML 1.0 specification, the 'choice' pattern/rule signifies that any content particle in a choice list (declared in the DTD) may appear in the element content at the location where the choice list appears in the grammar

Instance Variables:
	items	<Collection | CCompoundType | MC_FileBTree | Stream>
				Collection of content particles!

VWXMLPattern subclass: #VWXMLConcretePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLConcretePattern commentStamp: '<historical>' prior: 0!
This class is the superclass to what are considered 'simple' patterns or constraint rules in the element content declarations. As seen from the class hiererarchy, instances of simple patterns include VWXMLAnyPattern, VWXMLEmptyPattern, VWXMLInitialPattern, VWXMLNamePattern, VWXMLPCDATAPattern and VWXMLTerminalPattern.

Subclasses must implement the following messages:
	testing
		matches:
!

VWXMLConcretePattern subclass: #VWXMLAnyPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLAnyPattern commentStamp: '<historical>' prior: 0!
This class represents the ANY element content constraint in an element type declaration. According to the XML 1.0 specification the ANY pattern/rule is used to indicate to the validating
parser that the element can contain any elements in any order, as long as it doesn't break any of the other rules of XML and the types of any child elements have been declared.!

VWXMLConcretePattern subclass: #VWXMLEmptyPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLEmptyPattern commentStamp: '<historical>' prior: 0!
This class represents the EMPTY element content constraint in an element type declaration. According to the XML 1.0 specification the EMPTY element declaration indicates that the element has no content!

VWXMLConcretePattern subclass: #VWXMLInitialPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLInitialPattern commentStamp: '<historical>' prior: 0!
Since an element's content declaration may include multiple constraint rules or patterns, instances of this class are used to indicate to the XML parser, the initial or first rule in the declaration!

VWXMLComplexPattern subclass: #VWXMLMixedPattern
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLMixedPattern commentStamp: '<historical>' prior: 0!
This class represents the 'mixed' element content constraint in an element type declaration. An element type has mixed content when elements of that type may contain both other child elements and character data (text) as specified in the element content declaration.

Note: For mixed content type elements, one can't control the order in which the child elements, mixed in among the text, appear.

Instance Variables:
	items	<SequenceableCollection>  comment
!

VWXMLComplexPattern subclass: #VWXMLModifiedPattern
	instanceVariableNames: 'node modification '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLModifiedPattern commentStamp: '<historical>' prior: 0!
XML element content declarations can have certain optional characters following an element
name or pattern. These characters govern whether the element or the content particle may occur
one or more (+), zero or more (*), or zero or one (?) times in the element content. This class
represents these patterns or rules

Instance Variables:
	node	<VWXMLPattern>
	modification	<Character> Optional character denoting content element occurances
!

VWXMLConcretePattern subclass: #VWXMLNamePattern
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLNamePattern commentStamp: '<historical>' prior: 0!
This class represents a content constraint in an element type declaration such that the declaration includes the names of the element types that may appear as children in the element's content

Instance Variables:
	name	<VWXMLNodeTag>!

VWXMLConcretePattern subclass: #VWXMLPCDATAPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLPCDATAPattern commentStamp: '<historical>' prior: 0!
This class represents a content constraint or pattern in an element type declaration indicating that the element content includes parsed character data. This is typically used in mixed content type patterns and is signified by the presence of the string '#PCDATA' in the element content
declaration.!

VWXMLPattern class
	instanceVariableNames: ''!
VWXMLComplexPattern class
	instanceVariableNames: ''!
VWXMLChoicePattern class
	instanceVariableNames: ''!
VWXMLConcretePattern class
	instanceVariableNames: ''!
VWXMLAnyPattern class
	instanceVariableNames: ''!
VWXMLEmptyPattern class
	instanceVariableNames: ''!
VWXMLInitialPattern class
	instanceVariableNames: ''!
VWXMLMixedPattern class
	instanceVariableNames: ''!
VWXMLModifiedPattern class
	instanceVariableNames: ''!
VWXMLNamePattern class
	instanceVariableNames: ''!
VWXMLPCDATAPattern class
	instanceVariableNames: ''!
Object subclass: #VWXMLSAXDriver
	instanceVariableNames: 'locator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-SAX'!

!VWXMLSAXDriver commentStamp: '<historical>' prior: 0!
All methods in this class were modified from the orginal Cincom's class by Roger Whitney whitney@cs.sdsu.edu. 4/2/2000

This class includes supports for the Simple API for XML 2.0 (SAX), an event-driven API for parsing XML documents.
See http://www.megginson.com/SAX/SAX2/ for the Java API defining SAX. The XML 1.0 spec (http://www.w3.org/TR/REC-xml) will also be useful. 

This class is a Smalltalk implementation of the SAX DefaultHandler class. It implemets the SAX interfaces: ContentHandler, DTDHandler, EntityHandler and ErrorHandler, with three exceptions. See below.

To use this class you must create a subclass, and override any method of interest. Nearly all the methods in
this class are empty. Instance creation methods are the same as VWXMLXMLParser. See OXSAXIndenter for an example. Implementation note: All creation methods in the class must eventually call on:beforeScanDo: for the SAX error handling to work.

Instance Variables:
	locator <OXSAXLocator> maintains location of the parser in current XML document

The three methods in the SAX DefaultHandler definition not implemented here are:
ContentHandler>>endPrefixMapping
ContentHandler>>startPrefixMapping
	The parser keeps track of the namespaces, all tags and attributes are passed to theSAX application 
	with namespace information. Hence these methods seemed redundent.

ContentHandler>>skippedEntity
	When the parser is in validating mode is does not skip entities. I could not find were the parser 
	skips entities when in non-validiating mode to implement this method
!

VWXMLSAXDriver subclass: #VWXMLDOMSAXDriver
	instanceVariableNames: 'stack document '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-SAX'!

!VWXMLDOMSAXDriver commentStamp: '<historical>' prior: 0!
This class represents a specialized type of SAX (Simple API for XML) processor that follows the 'object model' for processing XML documents to build a VWXMLDocument Object Model (DOM) tree from the processed XML document.

Note: This class implementation is not yet complete

Instance Variables:
	stack	<OrderedCollection>
	document	<VWXMLDocument>
!

VWXMLSAXDriver class
	instanceVariableNames: ''!
VWXMLDOMSAXDriver class
	instanceVariableNames: ''!
VWXMLComplexPattern subclass: #VWXMLSequencePattern
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLSequencePattern commentStamp: '<historical>' prior: 0!
This class represents the 'sequence' element content constraint in an element type declaration. According to the XML 1.0 specification, the 'sequence' pattern/rule signifies that content particles occuring in a sequence list (declared in the DTD) must each appear in the element content in the order given in the list.

Instance Variables:
	items	<SequenceableCollection> Collection of content particles
!

VWXMLSequencePattern class
	instanceVariableNames: ''!
Link subclass: #VWXMLStreamWrapper
	instanceVariableNames: 'stream isInternal protocol name usedAsExternal entity cr lf '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLStreamWrapper commentStamp: '<historical>' prior: 0!
This class is used by the VWXMLXMLParser to wrap both internal and external streams with proper encoding before handing them to the parser for processing

Instance Variables:
	stream			<EncodedStream>  stream being wrapped
	isInternal		<Boolean>  true if the stream is internal and hencer doesn't need careful line-end treatment
	protocol			<String>  name of stream type, 'internal' or 'file'
	name			<String | nil>  the name of the stream, if it is named
	usedAsExternal	<Boolean>  flag used to override protocol and say how stream is being used?
	entity			<VWXMLEntity | nil>  if wrapping on behalf of an VWXMLEntity this is it?
	cr				<Character>  cache of Character cr
	lf				<Character>  cache of Character lf
!

VWXMLStreamWrapper class
	instanceVariableNames: ''!
VWXMLConcretePattern subclass: #VWXMLTerminalPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Patterns'!

!VWXMLTerminalPattern commentStamp: '<historical>' prior: 0!
Since an element's content declaration may include multiple constraint rules or patterns, instances of this class are used to indicate to the XML parser, the last or terminal rule in the declaration!

VWXMLTerminalPattern class
	instanceVariableNames: ''!
VWXMLNode subclass: #VWXMLText
	instanceVariableNames: 'text stripped '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Nodes'!

!VWXMLText commentStamp: '<historical>' prior: 0!
This class represents an XML textual object, i.e. a sequence of legal characters as defined in the XML 1.0 specification and may represent markup or character data.


Instance Variables:
	text	<CharacterArray | nil>
	stripped	<Boolean> 
!

VWXMLText class
	instanceVariableNames: ''!
Object subclass: #VWXMLURIResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLURIResolver commentStamp: '<historical>' prior: 0!
This class provides a simple API for resolving the Uniform Resource Identifiers (URI) found in XML documents!

VWXMLURIResolver class
	instanceVariableNames: ''!
Object subclass: #VWXMLXMLNodeBuilder
	instanceVariableNames: 'tagStack tags '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLXMLNodeBuilder commentStamp: '<historical>' prior: 0!
This class along with it's subclass VWXMLNodeBuilder is used by the VWXMLXMLParser to distill an XML document into it's component elements. Since XML elements are tag delimited and nest
properly within each other in a well-formed XML document, this class contains code to
process the tags and build a dictionary of xml elements

Instance Variables:
	tagStack	<OrderedCollection> 
	tags	<Dictionary>
!

VWXMLXMLNodeBuilder subclass: #VWXMLNodeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLNodeBuilder commentStamp: '<historical>' prior: 0!
This class along with it's superclass VWXMLXMLNodeBuilder is used by the VWXMLXMLParser to distill an XML document into it's component elements. This VWXMLNodeBuilder class in particular is used to create instances of the various XML elements that are included in the scanned-in XML document or document string.!

VWXMLXMLNodeBuilder class
	instanceVariableNames: ''!
VWXMLNodeBuilder class
	instanceVariableNames: ''!
Object subclass: #VWXMLXMLParser
	instanceVariableNames: 'sourceStack hereChar lastSource currentSource documentNode dtd unresolvedIDREFs builder validating ignore eol '
	classVariableNames: 'IllegalCharacters '
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLXMLParser commentStamp: '<historical>' prior: 0!
This class represents the main XML processor in the system. This  VWXMLXMLParser may be used as a validating or non-validating parser to scan and process an XML document and provide access to it's content and structure to a smalltalk application. This VWXMLXMLParser tries to follow the guidelines laid out in the W3C XML Version 1.0 specification.

Instance Variables:
	sourceStack	<VWXMLStreamWrapper>  stack of input streams that handles inclusion.
	hereChar	<Character>  the current character being parsed
	lastSource	<VWXMLStreamWrapper>  record of previous source used to check correct nesting
	currentSource	<VWXMLStreamWrapper>  current input stream (the top of sourceStack)
	documentNode	<VWXMLDocument>  the document created by parsing
	dtd	<VWXMLDocumentType>  the document type definition for the current document
	unresolvedIDREFs	<Collection>  collection of IDREfs that have yet to be resolved; used for validation
	builder	<VWXMLNodeBuilder>  node builder
	validating	<Boolean>  if true then the parse validates the XML
	ignore	<Boolean>  ?
	eol	<Character>  the end-of-line character in the source stream
!

VWXMLXMLParser class
	instanceVariableNames: ''!
Error subclass: #VWXMLXMLSignal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Exceptions'!

!VWXMLXMLSignal commentStamp: '<historical>' prior: 0!
"Order important for SAX. Need to catch Warning before Invalid before Malformed"
	XMLSignal := Error newSignal.
	MalformedSignal := XMLSignal newSignal.
	InvalidSignal := MalformedSignal newSignalMayProceed: true. "Modified for SAX"
	WarningSignal := InformationSignal.		"Added for SAX. REW"!

VWXMLXMLSignal subclass: #VWXMLMalformedSignal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Exceptions'!
VWXMLMalformedSignal subclass: #VWXMLInvalidSignal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Exceptions'!
VWXMLXMLSignal subclass: #VWXMLWarningSignal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Exceptions'!
VWXMLXMLSignal class
	instanceVariableNames: ''!
VWXMLMalformedSignal class
	instanceVariableNames: ''!
VWXMLInvalidSignal class
	instanceVariableNames: ''!
VWXMLWarningSignal class
	instanceVariableNames: ''!

!VWXMLAttributeDef methodsFor: 'accessing'!
default

	^default! !

!VWXMLAttributeDef methodsFor: 'accessing'!
default: n

	flags := 0.
	default := nil.
	n = #required
		ifTrue: [flags := 1]
		ifFalse: [n = #implied
			ifTrue: [flags := 2]
			ifFalse:
				[n class == Association
					ifFalse: [self error: 'Invalid default'].
				n key ifTrue: [flags := 4].
				default := n value]]! !

!VWXMLAttributeDef methodsFor: 'accessing'!
hasDefault

	^(self isImplied or: [self isRequired]) not! !

!VWXMLAttributeDef methodsFor: 'accessing'!
isFixed

	^(flags bitAnd: 4) = 4! !

!VWXMLAttributeDef methodsFor: 'accessing'!
isImplied

	^(flags bitAnd: 2) = 2! !

!VWXMLAttributeDef methodsFor: 'accessing'!
isRequired

	^(flags bitAnd: 1) = 1! !

!VWXMLAttributeDef methodsFor: 'accessing'!
name

	^name! !

!VWXMLAttributeDef methodsFor: 'accessing'!
name: n

	name := n! !

!VWXMLAttributeDef methodsFor: 'accessing'!
tag

	^name! !

!VWXMLAttributeDef methodsFor: 'accessing'!
type

	^type! !

!VWXMLAttributeDef methodsFor: 'accessing'!
type: n

	type := n! !

!VWXMLAttributeDef methodsFor: 'validating'!
completeValidationAgainst: aParser
	"Modifed to handle IMPLIED (no value to validate) attributes. REW"
	^self isImplied ifFalse: [type completeValidationAgainst: aParser from: self]! !

!VWXMLAttributeDef methodsFor: 'validating'!
selfValidateFor: aParser

	type validateDefinition: self for: aParser! !

!VWXMLAttributeDef methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	type validateValueOf: anAttribute for: aParser.
	(self isFixed not or: [anAttribute value = self default])
		ifFalse: [aParser invalid: ('The attribute "<1s>" was declared FIXED, but the value used in the document ("<2s>") did not match the default ("<3s>")'
						expandMacrosWith: anAttribute tag asString
						with: anAttribute value
						with: self default)].! !

!VWXMLAttributeDef methodsFor: 'private'!
value

	^self default! !

!VWXMLAttributeDef methodsFor: 'private'!
value: str

	default := str! !


!VWXMLAttributeType methodsFor: 'validating'!
completeValidationAgainst: aParser from: anAttribute

	^self! !

!VWXMLAttributeType methodsFor: 'validating'!
simpleValidateValueOf: anAttribute for: aParser

	| v |
	v := anAttribute value copy.
	v replaceAll: Character cr with: Character space.
	v replaceAll: Character lf with: Character space.
	v replaceAll: Character tab with: Character space.
	anAttribute value: v! !

!VWXMLAttributeType methodsFor: 'validating'!
validateDefinition: anAttributeDefinition for: aParser

	anAttributeDefinition hasDefault
		ifTrue: [self validateValueOf: anAttributeDefinition for: aParser]! !

!VWXMLAttributeType methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser
	"We're going to do this the hard way for now."

	| v v1 |
	self simpleValidateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	[v1 := v copyReplaceAll: '  ' with: ' '.
	v1 = v] whileFalse: [v := v1].
	(v size > 1 and: [v first = Character space])
		ifTrue: [v := v copyFrom: 2 to: v size].
	(v size > 1 and: [v last = Character space])
		ifTrue: [v := v copyFrom: 1 to: v size-1].
	anAttribute value: v! !

!VWXMLAttributeType methodsFor: 'testing'!
isID

	^false! !


!VWXMLCDATAat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	self simpleValidateValueOf: anAttribute for: aParser.! !


!VWXMLDocumentType methodsFor: 'accessing'!
attributeFor: key subKey: k2

	| val |
	(val := attributeDefs at: key asString ifAbsent: []) == nil
		ifTrue: [VWXMLXMLParser invalid: ('The attribute "<1s> <2s>" has not been defined'
							expandMacrosWith: key asString
							with: k2 asString)].
	^val at: k2 asString
		ifAbsent: [VWXMLXMLParser invalid: ('The attribute "<1s> <2s>" has not been defined'
							expandMacrosWith: key asString
							with: k2 asString)]! !

!VWXMLDocumentType methodsFor: 'accessing' !
attributeFor: key subKey: k2 put: value

	| dict |
	dict := attributeDefs at: key asString ifAbsentPut: [Dictionary new].
	(dict includesKey: k2 asString)
		ifTrue: [^self warn: ('The attribute "<1s> <2s>" has been defined more than once'
					expandMacrosWith: key asString
					with: k2 asString)].
	(value type isID and: [dict anySatisfy: [:attr | attr type isID]])
		ifTrue: [^VWXMLXMLParser invalid: ('The element <1s> has two attributes typed as ID' expandMacrosWith: key asString)].
	dict at: k2 asString put: value! !

!VWXMLDocumentType methodsFor: 'accessing'!
attributesFor: key

	^attributeDefs at: key asString ifAbsent: [Dictionary new]! !

!VWXMLDocumentType methodsFor: 'accessing'!
elementFor: key

	| val |
	(val := elementDefs at: key asString ifAbsent: []) == nil
		ifTrue: [self warn: ('The element "<1s>" has not been defined'
							expandMacrosWith: key asString)].
	^val! !

!VWXMLDocumentType methodsFor: 'accessing'!
elementFor: key put: value

	(elementDefs includesKey: key asString)
		ifTrue: [^self warn: ('The element "<1s>" has been defined more than once'
						expandMacrosWith: key asString)].
	elementDefs at: key asString put: value! !

!VWXMLDocumentType methodsFor: 'accessing'!
generalEntityAt: key
	"We do some tricks to make sure that, if the value
	is predefined in the parser, we use the predefined
	value. We could just store the predefined values
	in with the general ones, but we don't want to show
	warnings if the user (very correctly) defines them.
	An enhancement would be to let the user use his own
	values rather than the predefined ones, but we know
	that the predefined ones will be correct--we don't know
	that his will be."

	| val |
	val := PredefinedEntities at: key ifAbsent: [].
	val == nil
		ifTrue: [val := generalEntities at: key ifAbsent: []].
	^val! !

!VWXMLDocumentType methodsFor: 'accessing'!
generalEntityAt: key put: value

	(generalEntities includesKey: key)
		ifTrue: [^self warn: ('The general entity "<1s>" has been defined more than once'
				expandMacrosWith: key asString)].
	generalEntities at: key put: value! !

!VWXMLDocumentType methodsFor: 'accessing'!
notationAt: name

	^notations at: name ifAbsent: [VWXMLXMLParser invalid: 'Reference to an undeclared Notation']! !

!VWXMLDocumentType methodsFor: 'accessing'!
notationAt: name ifAbsent: aBlock

	^notations at: name ifAbsent: aBlock! !

!VWXMLDocumentType methodsFor: 'accessing'!
notationAt: name put: notation

	(notations includesKey: name)
		ifTrue: [VWXMLXMLParser invalid: 'Duplicate definitions for a Notation'].
	notations at: name put: notation! !

!VWXMLDocumentType methodsFor: 'accessing'!
parameterEntityAt: key

	^parameterEntities at: key ifAbsent: []! !

!VWXMLDocumentType methodsFor: 'accessing'!
parameterEntityAt: key put: value

	(parameterEntities includesKey: key)
		ifTrue: [^self warn: ('The parameter entity "<1s>" has been defined more than once'
						expandMacrosWith: key)].
	parameterEntities at: key put: value! !

!VWXMLDocumentType methodsFor: 'initialize'!
initialize

	notations := Dictionary new.
	elementDefs := Dictionary new.
	attributeDefs := Dictionary new.
	generalEntities := Dictionary new.
	parameterEntities := Dictionary new.! !

!VWXMLDocumentType methodsFor: 'private'!
completeValidationAgainst: aParser

	generalEntities keysAndValuesDo: [:eName :entity |
		entity completeValidationAgainst: aParser].
	attributeDefs keysAndValuesDo: [:eName :attribs |
		attribs keysAndValuesDo: [:aName :attrib |
			attrib completeValidationAgainst: aParser]]! !

!VWXMLDocumentType methodsFor: 'private'!
warn: aString
	"Modified to unify warnings for SAX. REW"
	^VWXMLXMLParser warn: aString! !


!VWXMLDocumentType class methodsFor: 'instance creation'!
new

	^super new initialize! !

!VWXMLDocumentType class methodsFor: 'class initialization'!
initialize
	"VWXMLDocumentType initialize"

	PredefinedEntities := Dictionary new
		at: 'amp' put: ( VWXMLGeneralEntity new name: 'amp'; text: '&#38;');
		at: 'lt' put: (VWXMLGeneralEntity new name: 'lt'; text: '&#60;');
		at: 'gt' put: (VWXMLGeneralEntity new name: 'gt'; text: (String with: $>));
		at: 'apos' put: (VWXMLGeneralEntity new name: 'apos'; text: '&#39;'); "Modified REW"
		at: 'quot' put: (VWXMLGeneralEntity new name: 'quot'; text: '&#34;'); "Modified REW"
		yourself! !


!VWXMLENTITIESat methodsFor: 'validating'!
completeValidationAgainst: aParser from: anAttribute
	"Check for nil added. REW"
	anAttribute value notNil
		ifTrue:[^self validateValueOf: anAttribute for: aParser]! !

!VWXMLENTITIESat methodsFor: 'validating'!
validateDefinition: anAttributeDefinition for: aParser

	^self! !

!VWXMLENTITIESat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v ent |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v tokensBasedOn: Character space) do: [:nm |
		(aParser isValidName: nm)
			ifFalse: [aParser invalid: ('An ENTITIES attribute (<1s>="<2s>") does not match the required syntax of a list of Names.'
					expandMacrosWith: anAttribute tag asString
					with: v)].
		ent := aParser dtd generalEntityAt: nm.
		ent == nil
			ifTrue: [aParser invalid: ('Undeclared unparsed entity "<1s>" used by attribute type "<2s>"'
						expandMacrosWith: nm
						with: anAttribute tag asString)]
			ifFalse: [ent isParsed
				ifTrue: [aParser invalid: ('The entity "<1s>" used by attribute type "<2s>" is a parsed entity and should be unparsed'
							expandMacrosWith: nm
							with: anAttribute tag asString)]
				ifFalse: []]]! !


!VWXMLENTITYat methodsFor: 'validating'!
completeValidationAgainst: aParser from: anAttribute
	"Check for nil added. REW"
	anAttribute value notNil
		ifTrue:[^self validateValueOf: anAttribute for: aParser]! !

!VWXMLENTITYat methodsFor: 'validating'!
validateDefinition: anAttributeDefinition for: aParser

	^self! !

!VWXMLENTITYat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v ent |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v includes: Character space)
		ifTrue: [aParser notPermitted: 'white space in ENTITY attributes'].
	(aParser isValidName: v)
		ifFalse: [aParser invalid: ('An ENTITY attribute (<1s>="<2s>") does not match the required syntax of a Name.'
					expandMacrosWith: anAttribute tag asString
					with: v)].
	ent := aParser dtd generalEntityAt: v.
	ent == nil
		ifTrue: [aParser invalid: ('Undeclared unparsed entity "<1s>" used by attribute type "<2s>"'
						expandMacrosWith: v
						with: anAttribute tag asString)]
		ifFalse: [ent isParsed
			ifTrue: [aParser invalid: ('The entity "<1s>" used by attribute type "<2s>" is a parsed entity and should be unparsed'
							expandMacrosWith: v
							with: anAttribute tag asString)]
			ifFalse: []]! !


!VWXMLENUMERATIONat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(values includes: v)
		ifFalse: [aParser invalid: ('An attribute (<1s>="<2s>") should have had a value from <3p>.'
					expandMacrosWith: anAttribute tag asString
					with: v
					with: values asArray)]! !

!VWXMLENUMERATIONat methodsFor: 'accessing'!
values: aList

	values := aList! !


!VWXMLENUMERATIONat class methodsFor: 'instance creation'!
withAll: list

	^self new values: list! !


!VWXMLElementContext methodsFor: 'testing'!
definesNamespaces

	^namespaces notNil and: [namespaces isEmpty not]! !

!VWXMLElementContext methodsFor: 'namespaces'!
defineDefaultNamespace: attribute

	self namespaces at: '' put: attribute value! !

!VWXMLElementContext methodsFor: 'namespaces'!
defineNamespace: attribute

	(#('xmlns' 'xml') includes: attribute tag type)
		ifTrue: [self error: ('It is illegal to redefine the qualifier "<1s>".' expandMacrosWith: attribute tag type)].
	attribute value isEmpty ifTrue: [VWXMLXMLParser invalid: 'It is not permitted to have an empty URI as a namespace name'].
	self namespaces at: attribute tag type put: attribute value! !

!VWXMLElementContext methodsFor: 'namespaces'!
findNamespace: ns

	^namespaces isNil
		ifTrue: [nil]
		ifFalse: [namespaces at: ns ifAbsent: [nil]]! !

!VWXMLElementContext methodsFor: 'accessing'!
namespaces

	namespaces == nil ifTrue: [namespaces := Dictionary new].
	^namespaces! !

!VWXMLElementContext methodsFor: 'accessing'!
tag

	^tag! !

!VWXMLElementContext methodsFor: 'accessing'!
tag: aTag

	tag := aTag isString
			ifTrue: [VWXMLNodeTag new qualifier: '' ns: '' type: aTag]
			ifFalse: [aTag].! !


!VWXMLIDREFSat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v tokensBasedOn: Character space) do: [:nm |
		(aParser isValidName: nm)
			ifFalse: [aParser invalid: ('An IDREFS attribute (<1s>="<2s>") does not match the required syntax of a list of Names.'
					expandMacrosWith: anAttribute tag asString
					with: v)].
		aParser rememberIDREF: nm]! !


!VWXMLIDREFat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v includes: Character space)
		ifTrue: [aParser notPermitted: 'white space in IDREF attributes'].
	(aParser isValidName: v)
		ifFalse: [aParser invalid: ('An IDREF attribute (<1s>="<2s>") does not match the required syntax of a Name.'
					expandMacrosWith: anAttribute tag asString
					with: v)].
	aParser rememberIDREF: v! !


!VWXMLIDat methodsFor: 'testing'!
isID

	^true! !

!VWXMLIDat methodsFor: 'validating'!
validateDefinition: anAttributeDefinition for: aParser

	anAttributeDefinition hasDefault
		ifTrue: [VWXMLXMLParser invalid: 'ID attributes must be either #REQUIRED or #IMPLIED']! !

!VWXMLIDat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v includes: Character space)
		ifTrue: [aParser notPermitted: 'white space in ID attributes'].
	(aParser isValidName: v)
		ifFalse: [aParser invalid: ('An ID attribute (<1s>="<2s>") does not match the required syntax of a Name.'
					expandMacrosWith: anAttribute tag asString
					with: v)].
	aParser documentNode registerID: anAttribute from: aParser! !


!VWXMLNMTOKENSat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v tokensBasedOn: Character space) do: [:nm |
		(aParser isValidNmToken: nm)
			ifFalse: [aParser invalid: ('An NMTOKENS attribute (<1s>="<2s>") does not match the required syntax of a list of NmTokens.'
					expandMacrosWith: anAttribute tag asString
					with: v)]]! !


!VWXMLNMTOKENat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(v includes: Character space)
		ifTrue: [aParser notPermitted: 'white space in IDREF attributes'].
	(aParser isValidNmToken: v)
		ifFalse: [aParser invalid: ('An NMTOKEN attribute (<1s>="<2s>") does not match the required syntax of an NmToken.'
					expandMacrosWith: anAttribute tag asString
					with: v)]! !


!VWXMLNOTATIONat methodsFor: 'validating'!
completeValidationAgainst: aParser from: anAttributeDef

	typeNames do: [:nm |
		aParser  dtd notationAt: nm ifAbsent:
			[aParser invalid: ('Undeclared Notation "<1s>" used by attribute type "<2s>"'
							expandMacrosWith: nm
							with: anAttributeDef tag asString)]]! !

!VWXMLNOTATIONat methodsFor: 'validating'!
validateValueOf: anAttribute for: aParser

	| v |
	super validateValueOf: anAttribute for: aParser.
	v := anAttribute value.
	(typeNames includes: v)
		ifFalse: [aParser invalid: ('A NOTATION attribute (<1s>="<2s>") should have had a value from <3p>.'
					expandMacrosWith: anAttribute tag asString
					with: v
					with: typeNames asArray)].! !

!VWXMLNOTATIONat methodsFor: 'accessing'!
typeNames

	^typeNames! !

!VWXMLNOTATIONat methodsFor: 'accessing'!
typeNames: aList

	typeNames := aList! !


!VWXMLNOTATIONat class methodsFor: 'instance creation'!
typeNames: list

	^self new typeNames: list! !


!VWXMLNode methodsFor: 'namespaces' stamp: 'BJP 3/13/2000 15:28'!
findNamespaceAt: qualifier

	| ns node |
	qualifier = 'xml' ifTrue: [^'http://www.w3.org/XML/1998/namespace'].
	ns := nil.
	node := self.
	[node isElement and: [ns == nil]]
		whileTrue:
			[ns := node namespaceAt: qualifier.
			node := node parent].
	^ns
! !

!VWXMLNode methodsFor: 'namespaces'!
findQualifierAtNamespace: ns

	| qual node |
	qual := nil.
	node := self.
	[node isElement and: [qual == nil]]
		whileTrue:
			[qual := node qualifierAtNamespace: ns.
			node := node parent].
	^qual! !

!VWXMLNode methodsFor: 'namespaces'!
namespaceAt: qualifier

	^nil! !

!VWXMLNode methodsFor: 'namespaces'!
qualifierAtNamespace: ns

	^nil! !

!VWXMLNode methodsFor: 'accessing'!
discard

	self flags: (self flags bitOr: 1)! !

!VWXMLNode methodsFor: 'accessing'!
document

	^parent document! !

!VWXMLNode methodsFor: 'accessing'!
expandedName

	^''! !

!VWXMLNode methodsFor: 'accessing'!
flags

	^flags! !

!VWXMLNode methodsFor: 'accessing'!
flags: flagBits

	flags := flagBits! !

!VWXMLNode methodsFor: 'accessing'!
parent

	^parent! !

!VWXMLNode methodsFor: 'accessing'!
parent: aNode

	parent := aNode! !

!VWXMLNode methodsFor: 'accessing'!
selectNodes: aBlock

	^#()! !

!VWXMLNode methodsFor: 'accessing'!
tag

	^nil! !

!VWXMLNode methodsFor: 'printing'!
canonicalPrintString

	| s |
	s := (String new: 1024) writeStream.
	self printCanonicalOn: s.
	^s contents! !

!VWXMLNode methodsFor: 'printing'!
noIndentPrintString

	| s |
	s := (String new: 1024) writeStream.
	self printNoIndentOn: s.
	^s contents! !

!VWXMLNode methodsFor: 'printing'!
printCanonical: text on: aStream
	"Print myself on the stream in the form described by James
	Clark's canonical XML."

	| d |
	d := Dictionary new.
	d at: Character cr put: '&#13;';
		at: Character lf put: '&#10;';
		at: Character tab put: '&#9;';
		at: $& put: '&amp;';
		at: $< put: '&lt;';
		at: $> put: '&gt;';
		at: $" put: '&quot;'.
	text do: [:c |
		aStream nextPutAll: (d at: c ifAbsent: [String with: c])].! !

!VWXMLNode methodsFor: 'printing'!
printCanonicalOn: aStream
	"Print myself on the stream in the form described by James
	Clark's canonical XML."

	self subclassResponsibility! !

!VWXMLNode methodsFor: 'printing'!
printHTMLOn: aStream
	"Print myself on the stream in a form usual for HTML."

	self subclassResponsibility! !

!VWXMLNode methodsFor: 'printing'!
printNoIndentOn: aStream
	"Print myself on the stream with line breaks between adjacent
	elements, but no indentation."

	self printNoIndentOn: aStream
		endSpacing: [:node :list | aStream cr]
		spacing: [:node :list | aStream cr]! !

!VWXMLNode methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock
	"Print myself on the stream with line breaks between adjacent
	elements, but no indentation."

	self subclassResponsibility! !

!VWXMLNode methodsFor: 'printing'!
printOn: aStream

	self printOn: aStream depth: 0! !

!VWXMLNode methodsFor: 'printing'!
simpleDescription

	^self printString! !

!VWXMLNode methodsFor: 'testing'!
hasAncestor: aNode

	| p |
	p := self parent.
	[p == nil] whileFalse:
		[p == aNode ifTrue: [^true].
		p := p parent].
	^false! !

!VWXMLNode methodsFor: 'testing'!
hasSubNodes

	^false! !

!VWXMLNode methodsFor: 'testing'!
isAttribute

	^false! !

!VWXMLNode methodsFor: 'testing'!
isBlankText

	^false! !

!VWXMLNode methodsFor: 'testing'!
isComment

	^false! !

!VWXMLNode methodsFor: 'testing'!
isContent

	^false! !

!VWXMLNode methodsFor: 'testing'!
isDiscarded

	^(self flags bitAnd: 1) = 1! !

!VWXMLNode methodsFor: 'testing'!
isDocument

	^false! !

!VWXMLNode methodsFor: 'testing'!
isElement

	^false! !

!VWXMLNode methodsFor: 'testing'!
isLike: aNode

	^self class == aNode class! !

!VWXMLNode methodsFor: 'testing'!
isProcessingInstruction

	^false! !

!VWXMLNode methodsFor: 'testing'!
isText

	^false! !

!VWXMLNode methodsFor: 'testing'!
precedes: aNode

	| n1 n2 |
	aNode document == self document
		ifFalse: [self error: 'These nodes can''t be ordered. They are not in the same document.'].
	aNode == self document
		ifTrue: [^false].
	self == self document
		ifTrue: [^true].
	n1 := self.
	n2 := aNode.
	(n2 hasAncestor: n1) ifTrue: [^true].
	(n1 hasAncestor: n2) ifTrue: [^false].
	[n1 parent == n2 parent] whileFalse:
		[[n1 parent hasAncestor: n2 parent] whileTrue: [n1 := n1 parent].
		[n2 parent hasAncestor: n1 parent] whileTrue: [n2 := n2 parent].
		n1 parent == n2 parent
			ifFalse: [n1 := n1 parent. n2 := n2 parent]].
	^(n1 parent indexOf: n1) < (n1 parent indexOf: n2)! !

!VWXMLNode methodsFor: 'testing'!
verifyContents

	^true! !

!VWXMLNode methodsFor: 'initialize'!
initialize

	flags := 0.! !

!VWXMLNode methodsFor: 'enumerating'!
nodesDo: aBlock

	aBlock value: self! !


!VWXMLAttribute methodsFor: 'accessing'!
characterData

	^self value! !

!VWXMLAttribute methodsFor: 'accessing'!
expandedName

	^name expandedName! !

!VWXMLAttribute methodsFor: 'accessing'!
key

	^name! !

!VWXMLAttribute methodsFor: 'accessing'!
tag

	^name! !

!VWXMLAttribute methodsFor: 'accessing'!
value

	^value! !

!VWXMLAttribute methodsFor: 'accessing'!
value: aValue

	value := aValue! !

!VWXMLAttribute methodsFor: 'printing'!
printCanonicalOn: aStream

	aStream nextPutAll: self tag asString, '="'.
	self printCanonical: value on: aStream.
	aStream nextPutAll: '"'.! !

!VWXMLAttribute methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	aStream nextPutAll: self tag asString, '="'.
	self printCanonical: value on: aStream.
	aStream nextPutAll: '"'.! !

!VWXMLAttribute methodsFor: 'printing'!
printOn: aStream

	self printCanonicalOn: aStream! !

!VWXMLAttribute methodsFor: 'printing'!
simpleDescription

	^'@', self key! !

!VWXMLAttribute methodsFor: 'initialize'!
name: nm value: val

	name := nm isString
			ifTrue: [VWXMLNodeTag new qualifier: '' ns: '' type: nm]
			ifFalse: [nm].
	value := val! !

!VWXMLAttribute methodsFor: 'initialize'!
tag: aTag

	name := aTag! !

!VWXMLAttribute methodsFor: 'testing'!
isAttribute

	^true! !

!VWXMLAttribute methodsFor: 'testing'!
isLike: aNode

	^self class == aNode class
		and: [self tag isLike: aNode tag]! !


!VWXMLComment methodsFor: 'accessing'!
text

	^text! !

!VWXMLComment methodsFor: 'accessing'!
text: aText

	text := aText! !

!VWXMLComment methodsFor: 'testing'!
isComment

	^true! !

!VWXMLComment methodsFor: 'printing'!
printCanonicalOn: aStream

	^self! !

!VWXMLComment methodsFor: 'printing'!
printHTMLOn: aStream

	self printOn: aStream! !

!VWXMLComment methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	^self printOn: aStream! !

!VWXMLComment methodsFor: 'printing'!
printOn: aStream depth: indent

	aStream nextPutAll: '<!!--', (text == nil ifTrue: [''] ifFalse: [text]), '-->'! !


!VWXMLDocument methodsFor: 'enumerating'!
nodesDo: aBlock

	aBlock value: self.
	1 to: self elements size do: [:i |
		(self elements at: i) nodesDo: aBlock]! !

!VWXMLDocument methodsFor: 'accessing'!
addNamespaceDefinitions

	| d tag |
	d := Dictionary new.
	self nodesDo: [:aNode |
		tag := aNode tag.
		tag isNil
			ifFalse:
				[(d at: tag qualifier ifAbsent: [tag namespace]) = tag namespace
					ifFalse: [self error: 'Using the same tag for multiple namespaces is not currently supported'].
				d at: tag qualifier put: tag namespace]].
	(d at: '' ifAbsent: ['']) = ''
		ifTrue: [d removeKey: '' ifAbsent: []].
	d removeKey: 'xml' ifAbsent: [].
	d removeKey: 'xmlns' ifAbsent: [].
	self root namespaces: d! !

!VWXMLDocument methodsFor: 'accessing'!
addNode: aNode

	nodes add: aNode.
	aNode parent: self.
	aNode isElement
		ifTrue: [root == nil
			ifTrue: [root := aNode]
			ifFalse: [self error: 'It is illegal to have more than one element node at the top level in a document']]! !

!VWXMLDocument methodsFor: 'accessing'!
document

	^self! !

!VWXMLDocument methodsFor: 'accessing'!
dtd

	^dtd! !

!VWXMLDocument methodsFor: 'accessing'!
dtd: aDTD

	dtd := aDTD! !

!VWXMLDocument methodsFor: 'accessing'!
elements

	^nodes! !

!VWXMLDocument methodsFor: 'accessing'!
root

	^root! !

!VWXMLDocument methodsFor: 'accessing'!
selectNodes: aBlock

	^nodes select: aBlock! !

!VWXMLDocument methodsFor: 'accessing'!
xmlVersion: aString

	xmlVersion := aString! !

!VWXMLDocument methodsFor: 'flags'!
hasDTD

	^(self flags bitAnd: 16r100) = 16r100! !

!VWXMLDocument methodsFor: 'flags'!
hasExternalDTD

	^(self flags bitAnd: 16r200) = 16r200! !

!VWXMLDocument methodsFor: 'flags'!
noteDTD

	self flags: (self flags bitOr: 16r100)! !

!VWXMLDocument methodsFor: 'flags'!
noteExternalDTD

	self flags: (self flags bitOr: 16r200)! !

!VWXMLDocument methodsFor: 'flags'!
notePEReference

	self flags: (self flags bitOr: 16r400)! !

!VWXMLDocument methodsFor: 'flags'!
usesParameterEntities

	^(self flags bitAnd: 16r400) = 16r400! !

!VWXMLDocument methodsFor: 'testing'!
hasSubNodes

	^nodes size > 0! !

!VWXMLDocument methodsFor: 'testing'!
isContent

	^true! !

!VWXMLDocument methodsFor: 'testing'!
isDocument

	^true! !

!VWXMLDocument methodsFor: 'testing'!
verifyContents

	root verifyContents! !

!VWXMLDocument methodsFor: 'printing'!
printCanonicalOn: aStream

	nodes do: [:n | n printCanonicalOn: aStream]! !

!VWXMLDocument methodsFor: 'printing'!
printHTMLOn: aStream

	nodes do: [:n | n printHTMLOn: aStream]! !

!VWXMLDocument methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	nodes do: [:n | n printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock]! !

!VWXMLDocument methodsFor: 'printing'!
printOn: aStream

	nodes do: [:n | n printOn: aStream. aStream cr]! !

!VWXMLDocument methodsFor: 'IDs'!
atID: key ifAbsent: aBlock

	^ids at: key ifAbsent: aBlock! !

!VWXMLDocument methodsFor: 'IDs'!
updateIDs

	| attr |
	ids keys do: [:key |
		attr := ids at: key.
		(attr isAttribute and: [attr value = key])
			ifFalse: [self error: 'Attempt to update the ID dictionary twice'].
		ids at: key put: attr parent].! !

!VWXMLDocument methodsFor: 'initialize'!
initialize

	super initialize.
	nodes := OrderedCollection new.
	ids := Dictionary new.! !

!VWXMLDocument methodsFor: '-- all --'!
registerID: attribute from: aParser

	(ids includesKey: attribute value)
		ifTrue: [aParser invalid: ('The id "<1s>" was used more than once' expandMacrosWith: attribute value)].
	ids at: attribute value put: attribute.
	aParser resolveIDREF: attribute value! !


!VWXMLElement methodsFor: 'printing' stamp: 'BJP 3/13/2000 15:26'!
printCanonicalOn: aStream

	| elem az |
	aStream nextPut: $<.
	aStream nextPutAll: tag asString.
	attributes == nil
		ifFalse:
			[az := attributes asSortedCollection: [:x :y | x key < y key].
			az do: [:at |
				aStream space.
				at printCanonicalOn: aStream]].
	aStream nextPut: $>.
	elem := elements == nil
		ifTrue: [#()]
		ifFalse: [elements].
	elem do: [:e |
		e printCanonicalOn: aStream].
	aStream nextPutAll: '</', tag asString, '>'! !

!VWXMLElement methodsFor: 'printing' stamp: 'BJP 3/13/2000 15:27'!
printHTMLOn: aStream

	| elem az |
	aStream nextPut: $<.
	aStream nextPutAll: tag asString.
	attributes == nil
		ifFalse:
			[az := attributes asSortedCollection: [:x :y | x key < y key].
			az do: [:at |
				aStream space.
				at printOn: aStream]].
	aStream nextPut: $>.
	elem := elements == nil
		ifTrue: [#()]
		ifFalse: [elements].
	self isHTMLBlock ifTrue: [aStream cr].
	elem do: [:e |
		e printHTMLOn: aStream.
		self isHTMLBlock ifTrue: [aStream cr]].
	aStream nextPutAll: '</', tag asString, '>'! !

!VWXMLElement methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	| elem az |
	aStream nextPut: $<.
	aStream nextPutAll: tag asString.
	attributes == nil
		ifFalse:
			[az := attributes asSortedCollection: [:x :y | x key < y key].
			az do: [:at |
				aStream space.
				at printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock]].
	aStream nextPut: $>.
	elem := elements == nil
		ifTrue: [#()]
		ifFalse: [elements reject: [:e | e isBlankText]].
	(elem anySatisfy: [:e | e isElement])
		ifTrue:
			[endSpacingBlock value: self value: elem.
			elem do: [:e | e
					printNoIndentOn: aStream
					endSpacing: endSpacingBlock
					spacing: spacingBlock]
				separatedBy: [spacingBlock value: self value: elem].
			endSpacingBlock value: self value: elem]
		ifFalse: [elem do: [:e | e
					printNoIndentOn: aStream
					endSpacing: endSpacingBlock
					spacing: spacingBlock]].
	aStream nextPutAll: '</', tag asString, '>'! !

!VWXMLElement methodsFor: 'printing' stamp: 'BJP 7/20/2000 00:51'!
printOn: aStream depth: indent

	| elem |
	aStream nextPut: $<.
	aStream nextPutAll: tag asString.
	attributes == nil
		ifFalse: [1 to: attributes size do: 
			[:i | | a |
			a := attributes at: i.
			aStream space.
			a printOn: aStream]].
	elements == nil
		ifTrue: [aStream nextPutAll: '/>']
		ifFalse:
			[aStream nextPut: $>.
			elem := elements reject: [:str | str isText and: [str isStripped]].
			(elem size <= 1 and: [(elem anySatisfy: [:n | n isText not]) not])
				ifTrue: [elem do: [:e |
							e printOn: aStream depth: indent+1]]
				ifFalse:
					[1 to: elem size do: [:i | | e |
						e := elem at: i.
						aStream crtab: indent+1.
						e isString 
							ifTrue: [aStream nextPutAll: e]
							ifFalse: [e printOn: aStream depth: indent+1]].
					aStream crtab: indent].
			aStream nextPutAll: '</', tag asString, '>']! !

!VWXMLElement methodsFor: 'printing'!
simpleDescription

	^'<', self tag asString, '>'! !

!VWXMLElement methodsFor: 'accessing'!
anyElementNamed: elementName
	"This will return the receiver if its name matches the requirement."

	| list |
	list := self anyElementsNamed: elementName.
	list size > 1 ifTrue: [self error: 'There is not a unique element with this tag'].
	^list isEmpty ifFalse: [list first]! !

!VWXMLElement methodsFor: 'accessing'!
anyElementsNamed: elementName
	"This includes the receiver as one of the possibilities."

	| list |
	list := OrderedCollection new.
	self nodesDo: [:e |
		(e isElement and: [e tag isLike: elementName])
			ifTrue: [list add: e]].
	^list! !

!VWXMLElement methodsFor: 'accessing'!
attributes

	^attributes == nil
		ifTrue: [#()]
		ifFalse: [attributes]! !

!VWXMLElement methodsFor: 'accessing'!
characterData

	| str |
	str := (String new: 128) writeStream.
	self characterDataOnto: str.
	^str contents! !

!VWXMLElement methodsFor: 'accessing'!
characterDataOnto: str

	self elements do: [:i |
		i isContent ifTrue: [i characterDataOnto: str]].! !

!VWXMLElement methodsFor: 'accessing'!
definition

	^definition! !

!VWXMLElement methodsFor: 'accessing'!
definition: aPattern

	definition := aPattern! !

!VWXMLElement methodsFor: 'accessing'!
description

	^'an %<<1s>> element' expandMacrosWith: tag! !

!VWXMLElement methodsFor: 'accessing'!
elementNamed: elementName

	| list |
	list := self elementsNamed: elementName.
	list size = 1 ifFalse: [self error: 'There is not a unique element with this tag'].
	^list first! !

!VWXMLElement methodsFor: 'accessing'!
elements

	^elements == nil
		ifTrue: [#()]
		ifFalse: [elements]! !

!VWXMLElement methodsFor: 'accessing'!
elementsNamed: elementName

	^self elements select: [:e | e isElement and: [e tag isLike: elementName]]! !

!VWXMLElement methodsFor: 'accessing'!
expandedName

	^tag expandedName! !

!VWXMLElement methodsFor: 'accessing'!
indexOf: aChild

	aChild parent == self ifFalse: [^nil].
	^aChild isAttribute
		ifTrue: [-1]
		ifFalse: [elements indexOf: aChild ifAbsent: [nil]]! !

!VWXMLElement methodsFor: 'accessing'!
namespaces: aDictionary

	namespaces := aDictionary! !

!VWXMLElement methodsFor: 'accessing'!
selectNodes: aBlock

	^self attributes, self elements select: aBlock! !

!VWXMLElement methodsFor: 'accessing'!
tag

	^tag! !

!VWXMLElement methodsFor: 'accessing'!
valueOfAttribute: attributeName ifAbsent: aBlock

	^(self attributes
		detect: [:a | a tag isLike: attributeName]
		ifNone: [^aBlock value]) value! !

!VWXMLElement methodsFor: 'testing'!
hasSubNodes

	^elements size > 0 or: [attributes size > 0]! !

!VWXMLElement methodsFor: 'testing'!
isContent

	^true! !

!VWXMLElement methodsFor: 'testing'!
isElement

	^true! !

!VWXMLElement methodsFor: 'testing'!
isEmpty

	^elements == nil! !

!VWXMLElement methodsFor: 'testing'!
isHTMLBlock

	^#('p' 'html' 'head' 'body') includes: tag asLowercase! !

!VWXMLElement methodsFor: 'testing'!
isLike: aNode

	^self class == aNode class
		and: [self tag isLike: aNode tag]! !

!VWXMLElement methodsFor: 'testing'!
verifyContents

	self isEmpty
		ifFalse: [elements do: [:elm | elm verifyContents]]! !

!VWXMLElement methodsFor: 'namespaces'!
namespaceAt: qualifier

	^namespaces == nil
		ifTrue: [nil]
		ifFalse: [namespaces at: qualifier ifAbsent: [nil]]! !

!VWXMLElement methodsFor: 'namespaces'!
qualifierAtNamespace: ns

	^namespaces == nil
		ifTrue: [nil]
		ifFalse:
			[namespaces keysAndValuesDo: 
				[:qualifier :namespace | namespace = ns ifTrue: [^qualifier]].
			nil]! !

!VWXMLElement methodsFor: 'private'!
attributes: a

	attributes := a.
	a == nil ifFalse: [a do: [:i | i parent: self]].! !

!VWXMLElement methodsFor: 'private'!
condenseList

	elements == nil
		ifFalse: [elements size = 0
			ifTrue: [elements := nil]
			ifFalse: [elements := elements asArray]]! !

!VWXMLElement methodsFor: 'private'!
condenseText

	| elmts str tc |
	elmts := (Array new: elements size) writeStream.
	str := nil.
	elements do: [:elm |
		elm isText
			ifTrue:
				[str == nil ifTrue: [str := (String new: elm text size) writeStream].
				tc := elm class.
				str nextPutAll: elm text]
			ifFalse:
				[str == nil ifFalse: [elmts nextPut: (tc new text: str contents)].
				str := nil.
				elmts nextPut: elm]].
	str == nil ifFalse: [elmts nextPut: (tc new text: str contents)].
	elements := elmts contents.! !

!VWXMLElement methodsFor: 'private'!
elements: e

	elements := e.
	self isEmpty
		ifFalse:
			[self condenseText.
			elements do: [:elm | elm parent: self]]! !

!VWXMLElement methodsFor: 'private'!
setTag: t attributes: a elements: e

	tag := t isString
			ifTrue: [VWXMLNodeTag new qualifier: '' ns: '' type: t]
			ifFalse: [t].
	self attributes: a.
	self elements: e! !

!VWXMLElement methodsFor: 'modifying'!
addNode: aNode

	elements == nil
		ifTrue: [elements := OrderedCollection new]
		ifFalse: [elements class == Array
			ifTrue: [elements := elements asOrderedCollection]].
	elements add: aNode! !

!VWXMLElement methodsFor: 'enumerating'!
nodesDo: aBlock

	aBlock value: self.
	1 to: self attributes size do: [:i |
		(self attributes at: i) nodesDo: aBlock].
	1 to: self elements size do: [:i |
		(self elements at: i) nodesDo: aBlock]! !

!VWXMLElement methodsFor: 'initialize'!
initialize

	super initialize.
	tag := 'undefined'.
	attributes := #().! !


!VWXMLEntity methodsFor: 'testing'!
isExternal

	^publicID notNil or: [systemID notNil]! !

!VWXMLEntity methodsFor: 'testing'!
isParsed

	^true! !

!VWXMLEntity methodsFor: 'printing'!
basicPrintOn: aStream 
	aStream nextPutAll: self name! !

!VWXMLEntity methodsFor: 'printing' stamp: 'BJP 7/25/2000 20:32'!
printOn: aStream 
	self basicPrintOn: aStream.
	text == nil
		ifTrue: [aStream nextPutAll: '(' , systemID , ')']
		ifFalse: [aStream nextPutAll: '(' , text , ')']! !

!VWXMLEntity methodsFor: 'accessing'!
entityType

	^self subclassResponsibility! !

!VWXMLEntity methodsFor: 'accessing'!
externalFrom: anArray

	anArray class == Array
		ifFalse: [self error: 'External ID is expected to be an Array'].
	anArray size = 1
		ifTrue: [systemID := anArray at: 1]
		ifFalse: [anArray size = 2
			ifTrue:
				[publicID := anArray at: 1.
				systemID := anArray at: 2]
			ifFalse:
				[self error: 'External ID has too many or too few identifiers']]! !

!VWXMLEntity methodsFor: 'accessing'!
name

	^name! !

!VWXMLEntity methodsFor: 'accessing'!
name: aName

	name := aName! !

!VWXMLEntity methodsFor: 'accessing'!
streamFor: aParser

	(aParser hasExpanded: self)
		ifTrue: [aParser malformed: 'Can''t expand this entity; it is defined recursively'].
	text == nil
		ifTrue:
			[| uri str |
			uri := VWXMLURIResolver resolve: systemID from: aParser latestURI.
			aParser pushSource: (str := VWXMLStreamWrapper
								stream: (VWXMLURIResolver openStreamOn: uri)
								protocol: uri key
								name: uri value
								entity: self).
			str textDeclIn: aParser.
			aParser getNextChar]
		ifFalse:
			[aParser pushSource: (VWXMLStreamWrapper
								stream: text readStream
								protocol: 'internal'
								name: nil
								entity: self).
			aParser getNextChar].! !

!VWXMLEntity methodsFor: 'accessing'!
text: aString

	text := aString! !


!VWXMLGeneralEntity methodsFor: 'accessing'!
entityType

	^'generic'! !

!VWXMLGeneralEntity methodsFor: 'accessing'!
ndata: aNotifierNameOrNil

	ndata := aNotifierNameOrNil! !

!VWXMLGeneralEntity methodsFor: 'testing'!
isParsed

	^ndata == nil! !

!VWXMLGeneralEntity methodsFor: 'validation'!
completeValidationAgainst: aParser

	ndata isNil
		ifFalse: [aParser dtd notationAt: ndata ifAbsent:
				[aParser invalid: ('Unparsed entity "<1s>" uses an undeclared notation "<2s>"'
						expandMacrosWith: name
						with: ndata)]]! !


!VWXMLNode class methodsFor: 'instance creation'!
new

	^super new initialize! !


!VWXMLAttribute class methodsFor: 'instance creation'!
name: nm value: val

	^self new name: nm value: val! !


!VWXMLElement class methodsFor: 'instance creation'!
tag: tag

	^self new setTag: tag attributes: nil elements: nil! !

!VWXMLElement class methodsFor: 'instance creation'!
tag: tag attributes: attributes elements: elements

	^self new setTag: tag attributes: attributes elements: elements! !

!VWXMLElement class methodsFor: 'instance creation'!
tag: tag elements: elements

	^self new setTag: tag attributes: nil elements: elements! !


!VWXMLNodeTag methodsFor: 'comparing'!
< aNodeTag
	"Needed for canonical XML. REW" 
	^type < aNodeTag type! !

!VWXMLNodeTag methodsFor: 'comparing'!
= aNodeTag
	"Needed for canonical XML. REW" 
	^(namespace = aNodeTag namespace) and: [type = aNodeTag type]! !

!VWXMLNodeTag methodsFor: 'comparing'!
hash
	"Needed for canonical XML. REW" 
	^type hash! !

!VWXMLNodeTag methodsFor: 'accessing'!
expandedName

	^namespace isEmpty
		ifTrue: [type]
		ifFalse: [namespace, '#', type]! !

!VWXMLNodeTag methodsFor: 'accessing'!
namespace

	^namespace! !

!VWXMLNodeTag methodsFor: 'accessing'!
qualifier

	^qualifier! !

!VWXMLNodeTag methodsFor: 'accessing'!
type

	^type! !

!VWXMLNodeTag methodsFor: 'initialize'!
qualifier: q ns: ns type: typeStr

	namespace := ns isNil		"added for xml:lang comparison REW"
		ifTrue:['']
		ifFalse:[ns].
	type := typeStr.
	qualifier := q! !

!VWXMLNodeTag methodsFor: 'converting'!
asString

	^qualifier isEmpty
		ifTrue: [type]
		ifFalse: [qualifier, ':', type]! !

!VWXMLNodeTag methodsFor: 'printing'!
printOn: aStream

	aStream nextPutAll: '{', self asString, '}'! !

!VWXMLNodeTag methodsFor: 'testing'!
isLike: aName

	^aName isString
		ifTrue: [namespace isEmpty and: [type = aName]]
		ifFalse: [namespace = aName namespace and: [type = aName type]]! !


!VWXMLNotation methodsFor: 'initialize'!
name: aName identifiers: anArray

	name := aName.
	anArray size = 1
		ifTrue: [systemID := anArray at: 1]
		ifFalse: [anArray size = 2
			ifTrue:
				[systemID := anArray at: 2.
				publicID := anArray at: 1]
			ifFalse: [self error: 'Invalid PUBLIC / SYSTEM identifiers']]! !

!VWXMLNotation methodsFor: 'accessing'!
name
	"Needed for SAX. REW"
	^name! !

!VWXMLNotation methodsFor: 'accessing'!
publicID
	"Needed for SAX. REW"
	^publicID! !

!VWXMLNotation methodsFor: 'accessing'!
systemID
	"Needed for SAX. REW"
	^systemID! !


!VWXMLPI methodsFor: 'printing'!
printCanonicalOn: aStream

	aStream nextPutAll: '<?', name, ' ', text, '?>'! !

!VWXMLPI methodsFor: 'printing'!
printHTMLOn: aStream

	aStream nextPutAll: '<?', name, ' ', text, '?>'! !

!VWXMLPI methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	aStream nextPutAll: '<?', name, ' ', text, '?>'! !

!VWXMLPI methodsFor: 'printing'!
printOn: aStream depth: indent

	aStream nextPutAll: '<?', name, ' ', text, '?>'! !

!VWXMLPI methodsFor: 'testing'!
isLike: aNode

	^self class == aNode class
		and: [self name isLike: aNode name]! !

!VWXMLPI methodsFor: 'testing'!
isProcessingInstruction

	^true! !

!VWXMLPI methodsFor: 'accessing'!
name

	^name! !

!VWXMLPI methodsFor: 'accessing'!
text
	^text! !

!VWXMLPI methodsFor: 'initialize'!
name: nm text: aString

	name := nm.
	text := aString! !


!VWXMLPI class methodsFor: 'instance creation'!
name: nm text: aString

	^self new name: nm text: aString! !


!VWXMLParameterEntity methodsFor: 'accessing'!
entityType

	^'parameter'! !

!VWXMLParameterEntity methodsFor: 'accessing'!
streamFor: aParser addSpaces: spaces

	| myText |
	(aParser hasExpanded: self)
		ifTrue: [aParser malformed: 'Can''t expand this entity; it is defined recursively'].
	text == nil
		ifTrue:
			[| uri str |
			uri := VWXMLURIResolver resolve: systemID from: aParser latestURI.
			str := VWXMLStreamWrapper
						stream: (VWXMLURIResolver openStreamOn: uri)
						protocol: uri key
						name: uri value
						entity: self.
			str textDeclIn: aParser.
			text := str stream upToEnd.
			str close].
	myText := text.
	spaces ifTrue: [myText := ' ', text, ' '].
	aParser pushSource: (VWXMLStreamWrapper
						stream: myText readStream
						protocol: 'internal'
						name: nil
						entity: self).
	aParser getNextChar.! !


!VWXMLPattern methodsFor: 'initialize'!
initialize

	followSet := OrderedCollection new: 2! !

!VWXMLPattern methodsFor: 'coercing'!
addFollow: aNode

	followSet add: aNode! !

!VWXMLPattern methodsFor: 'coercing'!
addFollows: aList

	followSet addAll: aList! !

!VWXMLPattern methodsFor: 'coercing'!
alternateHeads

	^self subclassResponsibility! !

!VWXMLPattern methodsFor: 'coercing'!
followSet

	^followSet! !

!VWXMLPattern methodsFor: 'coercing'!
normalize

	| list done t r result |
	list := OrderedCollection
			with: (result := VWXMLInitialPattern new addFollow: self)
			with: self
			with: VWXMLTerminalPattern new.
	self addFollow: list last.
	done := OrderedCollection new.
	[list isEmpty]
		whileFalse:
			[t := list removeFirst.
			r := t pushDownFollowSet.
			r == nil
				ifTrue: [done add: t]
				ifFalse: [list addAll: r]].
	list := done.
	done := OrderedCollection new.
	[list isEmpty]
		whileFalse:
			[t := list removeFirst.
			t normalizeFollowSet
				ifTrue: [done add: t]
				ifFalse: [list add: t]].
	done do: [:p |
		p isSimple ifFalse: [self error: 'Incomplete translation'].
		p followSet do: [:p1 |
			p1 isSimple ifFalse: [self error: 'Incomplete translation']]].
	^result! !

!VWXMLPattern methodsFor: 'coercing' stamp: 'BJP 7/27/2000 14:56'!
normalizeFollowSet
	| changed oldFollow newFollow |
	oldFollow _ IdentitySet withAll: followSet.
	newFollow _ IdentitySet new.
	oldFollow
		do: [:pat | newFollow addAll: pat alternateHeads].
	changed _ newFollow size ~= oldFollow size
				or: [(newFollow reject: [ :i | oldFollow asSet includes: i]) size > 0].
	followSet _ newFollow asOrderedCollection.
	^ changed not! !

!VWXMLPattern methodsFor: 'coercing'!
pushDownFollowSet

	^self subclassResponsibility! !

!VWXMLPattern methodsFor: 'accessing'!
description
	"Default behavior. subclasses should do something more informative. REW"
	^self class printString! !

!VWXMLPattern methodsFor: 'printing'!
printOn: aStream

	aStream nextPutAll: self description! !

!VWXMLPattern methodsFor: 'testing'!
isSimple

	^self subclassResponsibility! !


!VWXMLComplexPattern methodsFor: 'testing'!
isSimple

	^false! !


!VWXMLChoicePattern methodsFor: 'coercing'!
alternateHeads

	^items! !

!VWXMLChoicePattern methodsFor: 'coercing'!
pushDownFollowSet

	items do: [:i | i addFollows: followSet].
	^items! !

!VWXMLChoicePattern methodsFor: 'initialize'!
on: aList

	items := aList! !


!VWXMLConcretePattern methodsFor: 'testing'!
canTerminate

	^followSet anySatisfy: [:p | p isTerminator]! !

!VWXMLConcretePattern methodsFor: 'testing'!
couldBeText

	^false! !

!VWXMLConcretePattern methodsFor: 'testing'!
isSimple

	^true! !

!VWXMLConcretePattern methodsFor: 'testing'!
isTerminator

	^false! !

!VWXMLConcretePattern methodsFor: 'testing'!
matches: aNode

	self subclassResponsibility! !

!VWXMLConcretePattern methodsFor: 'coercing'!
alternateHeads

	^Array with: self! !

!VWXMLConcretePattern methodsFor: 'coercing'!
pushDownFollowSet

	^nil! !

!VWXMLConcretePattern methodsFor: 'accessing'!
followSetDescription

	| s |
	s := (String new: 32) writeStream.
	s nextPut: $(.
	followSet do: [:n | s nextPutAll: n printString] "replaced n tag. REW"
		separatedBy: [s space].
	s nextPut: $).
	^s contents! !

!VWXMLConcretePattern methodsFor: 'validation'!
validate: node

	| couldBeText |
	couldBeText := false.
	self followSet do: [:i |
		i couldBeText
			ifTrue: [couldBeText := true].
		(i matches: node) 
			ifTrue: [^i]].
	couldBeText
		ifFalse: [node isBlankText ifTrue: [^self]].
	^nil! !


!VWXMLAnyPattern methodsFor: 'coercing'!
alternateHeads

	^followSet copyWith: self! !

!VWXMLAnyPattern methodsFor: 'coercing'!
pushDownFollowSet

	self addFollow: self.
	^nil! !

!VWXMLAnyPattern methodsFor: 'testing'!
couldBeText

	^true! !

!VWXMLAnyPattern methodsFor: 'testing'!
matches: aNode

	^true! !

!VWXMLAnyPattern methodsFor: 'accessing'!
description

	^'ANY'! !


!VWXMLEmptyPattern methodsFor: 'testing'!
matches: aNode

	^false! !

!VWXMLEmptyPattern methodsFor: 'coercing'!
alternateHeads

	^followSet! !


!VWXMLInitialPattern methodsFor: 'accessing'!
description
	"Needed for viewing in debuger. What should this return? REW"
	^'First rule in DTD'! !

!VWXMLInitialPattern methodsFor: 'validation'!
validateTag: tag content: content for: aParser

	| n |
	n := self.  
	content do: [:elm |
		elm isContent
			ifTrue:
				[n := n validate: elm.
				n == nil ifTrue: [aParser notPermitted: elm description, ' at this point in the "', tag printString, '" node']]].
	n canTerminate
		ifFalse: [aParser expected: 'one of ', n followSetDescription].
	^self! !


!VWXMLMixedPattern methodsFor: 'testing'!
couldBeText

	^true! !

!VWXMLMixedPattern methodsFor: 'coercing'!
alternateHeads

	^items, followSet! !

!VWXMLMixedPattern methodsFor: 'coercing'!
pushDownFollowSet

	items do: [:i | i addFollow: self; addFollows: followSet].
	^items! !

!VWXMLMixedPattern methodsFor: 'initialize'!
on: aList

	items := (Array with: VWXMLPCDATAPattern new), aList! !


!VWXMLModifiedPattern methodsFor: 'initialize'!
on: aNode type: t

	node := aNode.
	modification := t.! !

!VWXMLModifiedPattern methodsFor: 'accessing'!
description
	"added REW"
	^'MODIFIED' , (String with: modification)! !

!VWXMLModifiedPattern methodsFor: 'coercing'!
alternateHeads

	^(modification = $* or: [modification = $?])
		ifTrue: [followSet copyWith: node]
		ifFalse: [Array with: node]! !

!VWXMLModifiedPattern methodsFor: 'coercing'!
pushDownFollowSet

	(modification = $+ or: [modification = $*])
		ifTrue: [node addFollow: self].
	node addFollows: followSet.
	^Array with: node! !


!VWXMLNamePattern methodsFor: 'accessing'!
description

	^name printString! !

!VWXMLNamePattern methodsFor: 'accessing'!
name

	^name! !

!VWXMLNamePattern methodsFor: 'testing'!
matches: aNode

	^(aNode isElement and: [name isLike: aNode tag]) "or: [aNode isText not]"
	 "droped the trailing or: [aNode isText not] to correct bug handling things like <!!ELEMENT doc (a,  (b, c )*, d)>
	REW"! !

!VWXMLNamePattern methodsFor: 'initialize'!
named: aName

	name := aName! !


!VWXMLPCDATAPattern methodsFor: 'testing'!
matches: aNode

	^aNode isText! !

!VWXMLPCDATAPattern methodsFor: 'accessing'!
description

	^'#PCDATA'! !


!VWXMLPattern class methodsFor: 'instance creation'!
new

	^super new initialize! !


!VWXMLChoicePattern class methodsFor: 'instance creation'!
on: aList

	^self new on: aList! !


!VWXMLMixedPattern class methodsFor: 'instance creation'!
on: aList

	1 to: aList size do: [:i |
		i+1 to: aList size do: [:j |
			((aList at: i) name asString = (aList at: j) name asString)
				ifTrue: [VWXMLXMLParser invalid: 'Duplicate element names in a mixed content specification.']]].
	^self new on: (aList size = 0 ifTrue: [#()] ifFalse: [aList])! !


!VWXMLModifiedPattern class methodsFor: 'instance creation'!
on: aNode type: t

	^self new on: aNode type: t! !


!VWXMLNamePattern class methodsFor: 'instance creation'!
named: aName

	^self new named: aName! !


!VWXMLSAXDriver methodsFor: 'elements'!
endElement! !

!VWXMLSAXDriver methodsFor: 'elements'!
sourcePosition: pos inStream: str! !

!VWXMLSAXDriver methodsFor: 'elements'!
startElement: name atts: atts! !

!VWXMLSAXDriver methodsFor: 'document events'!
document

	^nil! !

!VWXMLSAXDriver methodsFor: 'document events'!
endDocumentFragment! !

!VWXMLSAXDriver methodsFor: 'document events'!
startDocumentFragment! !

!VWXMLSAXDriver methodsFor: 'other'!
attribute: name value: value

	^VWXMLAttribute name: name value: value! !

!VWXMLSAXDriver methodsFor: 'other'!
comment: data! !

!VWXMLSAXDriver methodsFor: 'other'!
notation: name value: val

	^VWXMLNotation new name: name identifiers: val! !

!VWXMLSAXDriver methodsFor: 'content handler'!
characters: aString

	"This method is used report character data of an entity.
	Character data with ignorable whitespace of a single entity is divided into parts. Each
	part is reported by its own call to this method. The ignorableWhitespace method is sent
	called between calls to this method. All white space separating parts of the text is passed
	to the ignorableWhitespace method.
	aString does not have any leading or trailing white space. "! !

!VWXMLSAXDriver methodsFor: 'content handler'!
documentLocator: anORSAXLocator
	"There is no need to override this method"

	locator := anORSAXLocator.! !

!VWXMLSAXDriver methodsFor: 'content handler'!
endDocument
	"Indicates that the parser has finished the document"! !

!VWXMLSAXDriver methodsFor: 'content handler'!
endElement: localName namespace: nameSpace prefix: nameSpacePrefix
	"indicates the end of an element. See startElement"! !

!VWXMLSAXDriver methodsFor: 'content handler'!
ignorableWhitespace: aString

	"Receive notification of ignorable whitespace in element content. 

	ignorable white space is any contiguous occurance of 2 or more white space characters
	(space, cr, tab, line feed, null , or form feed) or any white space character except space.
    
	All contiguous whitespace is sent in one call to this method.

      Parameters:
            aString - the white space"! !

!VWXMLSAXDriver methodsFor: 'content handler'!
processingInstruction: targetString data: dataString! !

!VWXMLSAXDriver methodsFor: 'content handler'!
startDocument
	"Indicates the start of a document"! !

!VWXMLSAXDriver methodsFor: 'content handler'!
startElement: localName namespace: namespace prefix: nameSpacePrefix attributes: attributes

	"Receive notification of the beginning of an element. 

      Parameters:
            localName <String> - The local name of the element(without prefix)
            namespace <String> The Namespace URI, Nil if the element has no Namespace URI
            prefix <String> Prefix of the tag name used to indicate a namespace. Nil if absent
            attributes <OrderedCollection of VWXMLAttribute (XML.Attribute)> The attributes attached to the element.

	Example (note two single quotes were used instead of a double quote char)
		<doc xmlns=''http://www.doc.org/'' xmlns:other=''http://www.other.com/''>
			<a>A text</a>
			<other:b>BA text</other:b>
			<c other:cat=''meow''>C text</c>
			<d xmlns=''http:/nested/''></d>
		</doc>

	Parameter values to this method for each element of the above XML:

	local name: 'doc' 	namespace: 'http://www.doc.org/'	prefix: ''
	local name: 'a' 	namespace: 'http://www.doc.org/'	prefix: ''
	local name: 'b' 	namespace: 'http://www.other.com/'	prefix: 'other'
	local name: 'c' 	namespace: 'http://www.doc.org/'	prefix: ''
	local name: 'd' 	namespace: 'http:/nested/'	prefix: ''

	Note the attribute object also have namespaces
"! !

!VWXMLSAXDriver methodsFor: 'dtd handler'!
notation: nameString publicID: publicIDString systemID: systemIDString
	"Receive notification of a notation declaration event. 

      It is up to the application to record the notation for later reference, if necessary.

      If a system identifier is present, and it is a URL, the SAX parser must resolve it fully before passing
      it to the application. (I do not know if the parser does resolve the URL. REW)"! !

!VWXMLSAXDriver methodsFor: 'dtd handler'!
unparsedEntity: nameString pubicID: publicIDString systemID: systemIDString
	"Note SAX 2.0 documentation also has notation name for the entity. 
	 Does not seem to be available from parser, and should be the same as nameString

	An unparsed entity is an external entity with ndata. See section 4.2.2 of the XML 1.0 spec"! !

!VWXMLSAXDriver methodsFor: 'error handler'!
error: anInvalidSignal
	"Called when a validating is on and parser reaches invalid XML. Is resumable"

	self halt: 'Invalid XML: ' ,anInvalidSignal messageText.
	anInvalidSignal resume.! !

!VWXMLSAXDriver methodsFor: 'error handler'!
fatalError: anXMLSignal
	"The XML parsers malformed and invalid signals are sent to this method"

	Error raiseSignal: anXMLSignal messageText! !

!VWXMLSAXDriver methodsFor: 'error handler'!
warning: aWarningSignal

	self halt: 'Warning: ' , aWarningSignal messageText.
	aWarningSignal resume! !

!VWXMLSAXDriver methodsFor: 'entity resolver'!
resolveEntity: anEntityNode
	"Called when the parser can not resolve an external entity. 
	 Currently the parser only resolves external entities that refer to files.

	 anEntityNode is an instance of VWXMLGeneralEntity (XML.GeneralEntity)

	Set the text for the entity (anEntityNode text: aString) so the compiler can 
	expand all references in the XML document to the entity. 

	Use the methods  publicID and systemID to get the nodes IDs to determine how
	to resolve the entity.  

	Currently there is no support for obtaining the location of the document source from the 
	parser to resolve relative references. "! !


!VWXMLDOMSAXDriver methodsFor: 'document events'!
document

	^document! !

!VWXMLDOMSAXDriver methodsFor: 'document events'!
endDocument

	document := stack removeLast.
	document isDocument ifFalse: [self error: 'End of Document not expected'].
	stack isEmpty ifFalse: [self error: 'End of Document not expected'].! !

!VWXMLDOMSAXDriver methodsFor: 'document events'!
endDocumentFragment

	document := stack removeLast.
	document isDocument ifFalse: [self error: 'End of Document not expected'].
	stack isEmpty ifFalse: [self error: 'End of Document not expected'].! !

!VWXMLDOMSAXDriver methodsFor: 'document events'!
startDocument

	stack := OrderedCollection with: VWXMLDocument new! !

!VWXMLDOMSAXDriver methodsFor: 'document events'!
startDocumentFragment

	stack := OrderedCollection with: VWXMLDocument new! !

!VWXMLDOMSAXDriver methodsFor: 'other'!
comment: data

	stack last addNode: (VWXMLComment new text: data)! !

!VWXMLDOMSAXDriver methodsFor: 'other'!
processingInstruction: target data: data

	stack last addNode: (VWXMLPI new name: target text: data)! !

!VWXMLDOMSAXDriver methodsFor: 'elements'!
endElement

	stack size = 0 ifTrue: [^self].
	stack removeLast condenseList! !

!VWXMLDOMSAXDriver methodsFor: 'elements'!
endElement: localName namespace: nameSpace prefix: nameSpacePrefix

	stack size = 0 ifTrue: [^self].
	stack removeLast condenseList! !

!VWXMLDOMSAXDriver methodsFor: 'elements'!
startElement: name atts: atts

	| elm |
	stack size = 0 ifTrue: [^self].
	elm := self createElement: name attributes: atts.
	stack last addNode: elm.
	stack addLast: elm! !

!VWXMLDOMSAXDriver methodsFor: 'elements'!
startElement: localName namespace: nameSpace prefix: nameSpacePrefix attributes: atts 
	| elm |
	stack size = 0 ifTrue: [^self].
	elm := self createElement: localName attributes: atts.
	stack last addNode: elm.
	stack addLast: elm! !

!VWXMLDOMSAXDriver methodsFor: 'private'!
createElement: name attributes: attr

	^VWXMLElement tag: name attributes: attr elements: OrderedCollection new! !

!VWXMLDOMSAXDriver methodsFor: 'characters'!
characters: aString

	stack last addNode: (VWXMLText text: aString)! !


!VWXMLSAXDriver class methodsFor: 'instance creation'!
on: aStream 
	^self on: aStream beforeScanDo: [:parser | ]! !

!VWXMLSAXDriver class methodsFor: 'instance creation'!
on: aStream beforeScanDo: aBlock 
	"aBlock: [:aParser | code]. use to send message to the parser before it parses the stream"

	| parser saxBuilder saxDriver |
	saxDriver := self new.
	saxBuilder := OXSAXBuilder driver: saxDriver source: aStream.
	parser := VWXMLXMLParser on: aStream.
	parser builder: saxBuilder.
	
	[[[aBlock value: parser.
	parser scanDocument] 
				on: VWXMLWarningSignal
				do: [:signal | saxDriver warning: signal]]
			on: VWXMLInvalidSignal
			do:[:invalid | saxDriver error: invalid]]
		on: VWXMLMalformedSignal
		do: [:error | saxDriver fatalError: error].
	^saxDriver! !

!VWXMLSAXDriver class methodsFor: 'instance creation'!
processDocumentInFilename: aFilename 

	^self processDocumentInFilename: aFilename beforeScanDo: [:parser | ]! !

!VWXMLSAXDriver class methodsFor: 'instance creation'!
processDocumentInFilename: aFilename beforeScanDo: aBlock
	"aBlock: [:aParser | code]. use to send message to the parser before it parses the document"
	| stream |
	stream := (aFilename asFilename withEncoding: #'UTF_8') readStream.
	stream lineEndTransparent.
	^self on: stream beforeScanDo: aBlock! !

!VWXMLSAXDriver class methodsFor: 'instance creation'!
processDocumentString: aString

	^self processDocumentString: aString beforeScanDo: [:parser | ]! !

!VWXMLSAXDriver class methodsFor: 'instance creation'!
processDocumentString: aString beforeScanDo: aBlock
	"aBlock: [:aParser | code]. use to send message to the parser before it parses the string"
	^self on: aString readStream beforeScanDo: aBlock! !


!VWXMLSequencePattern methodsFor: 'coercing'!
alternateHeads

	^Array with: items first! !

!VWXMLSequencePattern methodsFor: 'coercing'!
pushDownFollowSet

	1 to: items size-1 do: [:i |
		(items at: i) addFollow: (items at: i+1)].
	items last addFollows: followSet.
	^items! !

!VWXMLSequencePattern methodsFor: 'initialize'!
on: aList

	items := aList! !


!VWXMLSequencePattern class methodsFor: 'instance creation'!
on: aList

	^self new on: aList! !


!VWXMLStreamWrapper methodsFor: 'declaration'!
encodingDeclIn: aParser

	| enc |
	^stream peek = $e
		ifTrue:
			[| encoding |
			self mustFind: 'encoding' errorOn: aParser.
			self skipSpaceIn: aParser.
			self mustFind: '=' errorOn: aParser.
			self skipSpaceIn: aParser.
			encoding := self quotedString.
			aParser validateEncoding: encoding.
			((stream respondsTo: #encoding)
					and: [stream encoding asLowercase ~= (VWXMLXMLParser mapEncoding: encoding) asLowercase])
				ifTrue:
					[enc := (StreamEncoder new:
							(VWXMLXMLParser mapEncoding: encoding) asSymbol)
								initializeForFiles.
					stream encoder: enc].
			true]
		ifFalse: [false]! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
expected: string

	VWXMLXMLParser malformed: string, ' expected, but not found'! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
mustFind: str errorOn: aParser

	(self skipIf: str)
		ifFalse: [aParser expected: str].! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
quotedString

	(stream peekFor: $")
		ifTrue: [^(stream upTo: $") asString].
	(stream peekFor: $')
		ifTrue: [^(stream upTo: $') asString].
	self expected: 'quoted string'! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
sdDeclIn: aParser

	^stream peek = $s
		ifTrue:
			[| word |
			self mustFind: 'standalone' errorOn: aParser.
			self skipSpaceIn: aParser.
			self mustFind: '=' errorOn: aParser.
			self skipSpaceIn: aParser.
			word := self quotedString.
			(#('yes' 'no') includes: word)
				ifFalse: [aParser expected: 'yes or no'].
			true]
		ifFalse: [false]! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
skipIf: str

	| p |
	p := stream position.
	1 to: str size do: [:i |
		(stream peekFor: (str at: i))
			ifFalse:
				[stream position: p.
				^false]].
	^true! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
skipSpaceIn: aParser

	| p space |
	space := false.
	[p := stream position.
	#(9 10 13 32) includes: (self nextFor: aParser) asInteger]
		whileTrue: [space := true].
	stream position: p.
	^space! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
textDeclIn: aParser

	self checkEncoding.
	^(self skipIf: '<?xml')
		ifTrue:
			[| hasSpace |
			hasSpace := self skipSpaceIn: aParser.
			hasSpace
				ifTrue: [(self versionInfoIn: aParser) == nil
					ifFalse: [hasSpace := self skipSpaceIn: aParser]].
			hasSpace
				ifTrue: [(self encodingDeclIn: aParser)
					ifFalse: [self expected: 'encoding']]
				ifFalse: [(self encodingDeclIn: aParser)
					ifTrue: [self expected: 'white space']].
			self skipSpaceIn: aParser.
			self mustFind: '?>' errorOn: aParser.
			true]
		ifFalse: [false]! !

!VWXMLStreamWrapper methodsFor: 'declaration'!
versionInfoIn: aParser

	| version |
	^stream peek = $v
		ifTrue:
			[self mustFind: 'version' errorOn: aParser.
			self skipSpaceIn: aParser.
			self mustFind: '=' errorOn: aParser.
			self skipSpaceIn: aParser.
			version := self quotedString.
			version = '1.0' ifFalse: [self expected: 'version 1.0'].
			version]
		ifFalse: [nil]! !

!VWXMLStreamWrapper methodsFor: 'declaration' stamp: 'BJP 7/20/2000 10:57'!
xmlDeclIn: aParser
	(self skipIf: '<?xml version="1.0"?>') ifFalse: [
	self checkEncoding.
	^(self skipIf: '<?xml')
		ifTrue:
			[| hasSpace version |
			(self skipSpaceIn: aParser)
				ifTrue: [version := self versionInfoIn: aParser]
				ifFalse: [version := nil].
			version = nil ifTrue: [self expected: 'version'].
			aParser documentNode xmlVersion: version.
			hasSpace := self skipSpaceIn: aParser.
			hasSpace
				ifTrue: [(self encodingDeclIn: aParser)
					ifTrue: [hasSpace := self skipSpaceIn: aParser]]
				ifFalse: [(self encodingDeclIn: aParser)
					ifTrue: [self expected: 'white space']].
			hasSpace
				ifTrue: [(self sdDeclIn: aParser)
					ifTrue: [hasSpace := self skipSpaceIn: aParser]]
				ifFalse: [(self sdDeclIn: aParser)
					ifTrue: [self expected: 'white space']].
			self mustFind: '?>' errorOn: aParser.
			true]
		ifFalse: [false]]! !

!VWXMLStreamWrapper methodsFor: 'streaming'!
nextFor: aParser

	| ch n |
	ch := stream next.
	isInternal
		ifFalse:
			[lf == nil ifTrue: [self halt].
			ch == cr
				ifTrue:
					[stream peekFor: lf.
					ch := aParser eol]
				ifFalse: [ch == lf
					ifTrue: [ch := aParser eol]]].
	(ch isNil
			or: [(n := ch asInteger) < 16r110000   "IllegalCharacters size"
			and: [(VWXMLXMLParser illegalCharacters at: n+1) = 0]])
		ifFalse: [aParser notPermitted: 'a character with Unicode value ', n printString].
	^ch! !

!VWXMLStreamWrapper methodsFor: 'streaming'!
skip: n

	stream skip: n! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
characterSize: aCharacter

	^(self stream respondsTo: #encoder)
		ifTrue: [self stream encoder characterSize: aCharacter]
		ifFalse: [1]! !

!VWXMLStreamWrapper methodsFor: 'accessing' stamp: 'BJP 7/20/2000 12:31'!
checkEncoding

	| encoding |
	self flag: #PortIssue.
	"encoding := [stream encoding] on: Error do: [:ex | ex returnWith: #null].
	encoding = #'UTF_8'
		ifTrue:
			[| c1 c2 pos |
			pos := stream position.
			stream setBinary: true.
			c1 := stream next.
			c2 := stream next.
			stream setBinary: false.
			(c2 notNil and: [c1 * c2 = 16rFD02])
				ifTrue: [stream encoder: (UTF16StreamEncoder new
									forByte1: c1 byte2: c2)]
				ifFalse: [stream position: pos]]"! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
close

	stream isExternalStream ifTrue: [stream close]! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
contentsFor: aParser

	| s |
	s := (String new: 100) writeStream.
	[self atEnd]
		whileFalse: [s nextPut: (self nextFor: aParser)].
	^s contents! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
entity

	^entity! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
name
	| streamName |
	name ~~ nil ifTrue: [^name].
	stream isExternalStream ifFalse: [^nil].
	streamName := [stream name] on: Error do: [:ex| ex returnWith: nil].
	streamName ~~ nil ifTrue: [streamName replaceAll: Filename separator with: $/].
	^streamName! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
protocol

	^protocol! !

!VWXMLStreamWrapper methodsFor: 'accessing'!
stream

	^stream! !

!VWXMLStreamWrapper methodsFor: 'initialize'!
stream: str protocol: key name: value entity: ent

	stream := str.
	isInternal := key = 'internal'.
	protocol := key.
	name := value.
	entity := ent.
	cr := Character cr.
	lf := Character lf.! !

!VWXMLStreamWrapper methodsFor: 'initialize'!
usedAsExternal

	^usedAsExternal! !

!VWXMLStreamWrapper methodsFor: 'initialize'!
usedAsExternal: aBoolean

	usedAsExternal := aBoolean! !

!VWXMLStreamWrapper methodsFor: 'testing'!
atEnd

	^stream atEnd! !

!VWXMLStreamWrapper methodsFor: 'private'!
error: aStringOrMessage

	^VWXMLXMLParser error: aStringOrMessage! !


!VWXMLStreamWrapper class methodsFor: 'instance creation'!
emptyWithExtraSpace: space

	^self stream: (space ifTrue: ['  '] ifFalse: ['']) readStream
		protocol: 'internal'
		name: nil
		entity: nil! !

!VWXMLStreamWrapper class methodsFor: 'instance creation'!
stream: str protocol: key name: value entity: entity

	^self new stream: str protocol: key name: value entity: entity! !


!VWXMLTerminalPattern methodsFor: 'accessing'!
description

	^'<close tag>'! !

!VWXMLTerminalPattern methodsFor: 'testing'!
isTerminator

	^true! !

!VWXMLTerminalPattern methodsFor: 'testing'!
matches: aNode

	^false! !


!VWXMLText methodsFor: 'printing'!
printCanonicalOn: aStream

	text == nil ifTrue: [^self].
	self isStripped
		ifFalse: [self printCanonical: text on: aStream.]! !

!VWXMLText methodsFor: 'printing'!
printHTMLOn: aStream

	text == nil ifTrue: [^self].
	self isStripped
		ifFalse: [self printCanonical: text on: aStream.]! !

!VWXMLText methodsFor: 'printing'!
printNoIndentOn: aStream endSpacing: endSpacingBlock spacing: spacingBlock

	text == nil ifTrue: [^self].
	self isStripped
		ifFalse: [aStream nextPutAll: text]! !

!VWXMLText methodsFor: 'printing'!
printOn: aStream depth: indent

	aStream nextPutAll: (text == nil ifTrue: ['&nil;'] ifFalse: [text])! !

!VWXMLText methodsFor: 'accessing'!
characterData

	^self text! !

!VWXMLText methodsFor: 'accessing'!
characterDataOnto: str

	str nextPutAll: self text! !

!VWXMLText methodsFor: 'accessing'!
description

	^'text'! !

!VWXMLText methodsFor: 'accessing'!
strip: aBoolean

	stripped := aBoolean.! !

!VWXMLText methodsFor: 'accessing'!
text

	^text! !

!VWXMLText methodsFor: 'accessing'!
text: aText

	text := aText.
	stripped == nil ifTrue: [stripped := false].! !

!VWXMLText methodsFor: 'testing'!
isBlankText

	^(text anySatisfy: [:i | i isSeparator not]) not! !

!VWXMLText methodsFor: 'testing'!
isContent

	^true! !

!VWXMLText methodsFor: 'testing'!
isStripped

	^stripped! !

!VWXMLText methodsFor: 'testing'!
isText

	^true! !


!VWXMLText class methodsFor: 'instance creation'!
text: aString

	^self new text: aString! !


!VWXMLURIResolver class methodsFor: 'api' stamp: 'BJP 7/19/2000 23:17'!
openStreamOn: aURI

	| protocol nm |
self flag: #PortIssue.
	protocol := aURI key.
	protocol = 'file'
		ifTrue:
			[nm := aURI value copy. 
			nm := self flatten: nm.  		"added REW"
			nm replaceAll: $/ with: Filename separator.
			"Do some other massaging?"
			^CrLfFileStream readOnlyFileNamed: nm].
"(nm asFilename withEncoding: #'UTF_8') readStream lineEndTransparent]."
	self error: ('File access protocol "<1s>" is not supported'
			expandMacrosWith: protocol)! !

!VWXMLURIResolver class methodsFor: 'api'!
resolve: newName from: oldURI

	| colonIndex sepIndex protocol nm head |
	colonIndex := newName indexOf: $: ifAbsent: [newName size + 2].
	sepIndex := newName indexOf: $/ ifAbsent: [newName size + 1].
	colonIndex < sepIndex
		ifTrue:
			[protocol := newName copyFrom: 1 to: colonIndex-1.
			nm := newName copyFrom: colonIndex+1 to: newName size]
		ifFalse:
			[protocol := oldURI key.
			nm := newName].
	nm first = $/
		ifFalse:
			[head := oldURI value.
			sepIndex := head findLast: [:c | c = $/].
			sepIndex = 0
				ifTrue: [head := '.']
				ifFalse: [head := head copyFrom: 1 to: (head findLast: [:c | c = $/])-1].
			head isEmpty ifTrue: [self halt: 'head is empty'].
			nm := head, '/', nm].
	^protocol -> nm! !

!VWXMLURIResolver class methodsFor: 'private' stamp: 'BJP 7/20/2000 14:22'!
components: nameString
	"Break a file uri into path components, answer an OrderedCollection of components."

	| components separator  stream temp |
	components := OrderedCollection new.
	separator := $/.
	stream := nameString readStream.
	[stream atEnd]
		whileFalse:
			[temp := stream upTo: separator.
				stream atEnd ifFalse: [stream position: (stream position - 1). 
						 			  temp := temp , stream next asString] .
			components add: temp].
	^components! !

!VWXMLURIResolver class methodsFor: 'private'!
flatten: aFileURIString 
	"Remove parts of path that backtrack. That is /a/b/c/../../d becomes /a/d. REW"

	| flattenComponents newURI |
	flattenComponents := self removeUpComponents: (self components: aFileURIString).
	newURI := WriteStream on: (String new: aFileURIString size).
	flattenComponents do: [:each | newURI nextPutAll: each].
	^newURI contents! !

!VWXMLURIResolver class methodsFor: 'private'!
removeUpComponents: pathComponents 
	"Remove components of path that backtrack. That is /a/b/c/../../d becomes /a/d. REW"

	| flattenReversed upLevels |
	upLevels := 0.
	flattenReversed := pathComponents reverse select: 
			[:each | 
			(each = '../' or: [each = '..']) 
				ifTrue: 
					[upLevels := upLevels + 1.
					false]
				ifFalse:
					[upLevels > 0 
						ifTrue:
							[upLevels := upLevels - 1.
							false]
						ifFalse:[true]]].

	^flattenReversed reverse! !


!VWXMLXMLNodeBuilder methodsFor: 'initialize'!
initialize

	tagStack := OrderedCollection new.
	tags := Dictionary new.! !

!VWXMLXMLNodeBuilder methodsFor: 'namespaces'!
correctAttributeTag: attribute

	| ns tag key qual type |
	qual := attribute tag qualifier.
	qual isEmpty
		ifTrue: [^self].
	type := attribute tag type.
	ns := self findNamespace: qual.
	key := Array with: qual with: ns with: type.
	tag := tags at: key ifAbsentPut: [VWXMLNodeTag new qualifier: qual ns: ns type: type].
	attribute tag: tag! !

!VWXMLXMLNodeBuilder methodsFor: 'namespaces'!
correctTag: tag

	| ns type key qualifier |
	qualifier := tag qualifier.
	type := tag type.
	ns := self findNamespace: qualifier.
	key := Array with: qualifier with: ns with: type.
	^tags at: key ifAbsentPut: [VWXMLNodeTag new qualifier: qualifier ns: ns type: type]! !

!VWXMLXMLNodeBuilder methodsFor: 'namespaces'!
findNamespace: ns

	| nsURI |
	ns = 'xml' ifTrue: [^self class xmlUri].
	ns = 'xmlns' ifTrue: [^'<!!-- xml namespace -->'].
	tagStack size to: 1 by: -1 do: [:i |
		nsURI := (tagStack at: i) findNamespace: ns.
		nsURI = nil ifFalse: [^nsURI]].
	^ns = ''
		ifTrue: ['']
		ifFalse: [VWXMLXMLParser invalid: ('The namespace qualifier <1s> has not been bound to a namespace URI' expandMacrosWith: ns)]! !

!VWXMLXMLNodeBuilder methodsFor: 'namespaces'!
postProcessElement: anElement

	tagStack last definesNamespaces
		ifTrue: [anElement namespaces: tagStack last namespaces].
	^anElement! !

!VWXMLXMLNodeBuilder methodsFor: 'namespaces'!
resolveNamespaces: attributes

	| newAttributes |
	attributes == nil
		ifTrue: [newAttributes := #()]
		ifFalse:
			[newAttributes := OrderedCollection new: attributes size.
			attributes do: [:attr |
				newAttributes add: attr.
				attr tag qualifier = 'xmlns'
					ifTrue: [tagStack last defineNamespace: attr]
					ifFalse: [(attr tag isLike: 'xmlns')
						ifTrue: [tagStack last defineDefaultNamespace: attr]
						ifFalse: []]].
			newAttributes do: [:attr | self correctAttributeTag: attr]].
	tagStack last tag: (self correctTag: tagStack last tag).
	^newAttributes isEmpty
		ifTrue: [nil]
		ifFalse: [newAttributes asArray]! !

!VWXMLXMLNodeBuilder methodsFor: 'accessing'!
currentTag

	^tagStack last tag! !

!VWXMLXMLNodeBuilder methodsFor: 'accessing'!
pushTag: tag whileDoing: aBlock

	tagStack addLast: (VWXMLElementContext new tag: tag).
	^aBlock ensure: [tagStack removeLast]! !


!VWXMLNodeBuilder methodsFor: 'building'!
attribute: name value: value

	^VWXMLAttribute name: name value: value! !

!VWXMLNodeBuilder methodsFor: 'building'!
comment: aText

	^VWXMLComment new text: aText! !

!VWXMLNodeBuilder methodsFor: 'building'!
externalGeneralEntity: nameString id: arrayIDs ndata: ndata uri: aUri
	"Needed for SAX. REW" 
	^(VWXMLGeneralEntity new)
		externalFrom: arrayIDs;
		name: nameString;
		ndata: ndata! !

!VWXMLNodeBuilder methodsFor: 'building'!
externalParameterEntity: nameString id: arrayIDs
	"Needed for SAX. REW" 
	^(VWXMLParameterEntity new)
		externalFrom: arrayIDs;
		name: nameString! !

!VWXMLNodeBuilder methodsFor: 'building'!
internalGeneralEntity: nameString value: string
	"Needed for SAX. REW" 
	^(VWXMLGeneralEntity new)
		name: nameString;
		text: string! !

!VWXMLNodeBuilder methodsFor: 'building'!
internalParameterEntity: nameString value: string
	"Needed for SAX. REW" 
	^(VWXMLParameterEntity new)
		name: nameString;
		text: string! !

!VWXMLNodeBuilder methodsFor: 'building'!
makeText: text

	^VWXMLText text: text! !

!VWXMLNodeBuilder methodsFor: 'building'!
notation: name value: val

	^VWXMLNotation new name: name identifiers: val! !

!VWXMLNodeBuilder methodsFor: 'building'!
pi: nm text: text

	^VWXMLPI new name: nm text: text! !

!VWXMLNodeBuilder methodsFor: 'building'!
tag: tag attributes: attributes elements: elements position: p stream: stream

	^VWXMLElement tag: tag attributes: attributes elements: elements! !


!VWXMLXMLNodeBuilder class methodsFor: 'instance creation'!
new

	^super new initialize! !

!VWXMLXMLNodeBuilder class methodsFor: 'utility'!
xmlUri
	^'http://www.w3.org/XML/1998/namespace'! !


!VWXMLXMLParser methodsFor: 'api'!
comment

	| comment str1 |
	str1 := currentSource.
	^(self skipIf: '<!!--')
		ifTrue:
			[comment := self completeComment: str1.
			(ignore or: [comment isDiscarded])
				ifFalse: [self documentNode addNode: comment].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'api'!
docTypeDecl

	| nm id |
	^(self skipIf: '<!!DOCTYPE')
		ifTrue:
			[self forceSpace.
			self documentNode noteDTD.
			nm := self getQualifiedName.
			"nm yourself." "why? REW"
			self skipSpace.
			(id := self externalID: #docType) notNil ifTrue: [self skipSpace].
			self sourceWrapper usedAsExternal: false.
			(self skipIf: '[')
				ifTrue: [[self skipIf: ']']
					whileFalse: [self dtdEntry]].
			self sourceWrapper usedAsExternal: nil.
			id == nil ifFalse: [self dtdFile: id].
			self skipSpace.
			self mustFind: '>'.
			self isValidating ifTrue: [dtd completeValidationAgainst: self].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'api'!
misc

	^self atEnd not and: [self skipSpace or: [self comment or: [self pi]]]! !

!VWXMLXMLParser methodsFor: 'api'!
pi

	| str1 pi |
	str1 := currentSource.
	^(self skipIf: '<?')
		ifTrue:
			[pi := self completePI: str1.
			ignore ifFalse: [self documentNode addNode: pi].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'api' stamp: 'BJP 7/20/2000 10:57'!
prolog

self flag: #PortIssue.
	self sourceWrapper xmlDeclIn: self.       "This is optional."
											  "^^^^^^^^^^^^^^^ I, Bijan Parsia, am taking you at your word, here. This line triggers a bunch of checks on and, in VW, a shift in encoder streams. What would be nice is a good standard way to ignore all that if the Smalltalk system can't handle it, but to still let 'em deal with ASCII.

Methods rendered idle VWXMLStreamWrapper>>xmlDeclIn:, obviously, but also #encodingDeclIn:, #checkEncoding, and VWXMLXMLParser>>validateEncoding:"
	self getNextChar.
	[self misc] whileTrue.
	self docTypeDecl
		ifTrue: [[self misc] whileTrue].! !

!VWXMLXMLParser methodsFor: 'api'!
pushSource: aStreamWrapper

	aStreamWrapper nextLink: sourceStack.
	sourceStack := aStreamWrapper! !

!VWXMLXMLParser methodsFor: 'api'!
scanDocument

	^[self prolog. 
	self atEnd ifTrue: [self expected: 'Some XML content']. "added to handle incomplete XML REW"
	self documentNode addNode: self element.
	[self misc] whileTrue.
	self atEnd ifFalse: [self expected: 'comment or processing instruction'].
	self documentNode updateIDs.
	self checkUnresolvedIDREFs.
	self documentNode]
		ensure: [self closeAllFiles]! !

!VWXMLXMLParser methodsFor: 'testing'!
hasExpanded: anEntity

	| s |
	s := sourceStack.
	[s == nil] whileFalse:
		[s entity == anEntity
			ifTrue: [self malformed: ('The <1s> entity "<2s>" invokes itself recursively'
						expandMacrosWith: anEntity entityType
						with: anEntity name)].
		s := s nextLink].
	^false! !

!VWXMLXMLParser methodsFor: 'testing'!
isValidating

	^validating! !

!VWXMLXMLParser methodsFor: 'testing'!
shouldTestWFCEntityDeclared

	^self documentNode hasDTD not
		or: [(self documentNode hasExternalDTD not
			and: [self documentNode usesParameterEntities not])
		or: [self documentNode isDeclaredStandalone]]! !

!VWXMLXMLParser methodsFor: 'private'!
closeAllFiles

	self fullSourceStack do: [:str | str close]! !

!VWXMLXMLParser methodsFor: 'private'!
documentNode

	^documentNode! !

!VWXMLXMLParser methodsFor: 'private'!
error: aStringOrMessage

	^self class error: aStringOrMessage! !

!VWXMLXMLParser methodsFor: 'private'!
expected: string

	self malformed: string, ' expected, but not found'! !

!VWXMLXMLParser methodsFor: 'private'!
fullSourceStack

	| out s |
	out := OrderedCollection new.
	s := sourceStack.
	[s == nil]
		whileFalse:
			[out addFirst: s.
			s := s nextLink].
	^out! !

!VWXMLXMLParser methodsFor: 'private'!
getQualifiedName

	| nm |
	nm := self getSimpleName.
	^hereChar = $:
		ifTrue:
			[self getNextChar.
			VWXMLNodeTag new qualifier: nm ns: '' type: self getSimpleName]
		ifFalse:
			[VWXMLNodeTag new qualifier: '' ns: '' type: nm]! !

!VWXMLXMLParser methodsFor: 'private'!
getSimpleName

	| s |

	(self isValidNameStart: hereChar) ifFalse: [^self expected: 'name'].
	s := (String new: 16) writeStream.
	s nextPut: hereChar.
	[self getNextChar.
	self isValidNameChar: hereChar] whileTrue: [s nextPut: hereChar].
	^s contents! !

!VWXMLXMLParser methodsFor: 'private'!
invalid: aString

	self class invalid: aString! !

!VWXMLXMLParser methodsFor: 'private'!
isValidNameChar: c
	c isNil ifTrue:[^false]. "handles case when end of file is reached in middle of tag. REW"
	^c isLetter
		or: [c isDigit
		or: ['-_.' includes: c]]! !

!VWXMLXMLParser methodsFor: 'private'!
isValidNameStart: c

	^c isLetter or: [c = $_]! !

!VWXMLXMLParser methodsFor: 'private'!
malformed: aString

	self class malformed: aString! !

!VWXMLXMLParser methodsFor: 'private'!
nmToken

	| s |
	(self isValidNameChar: hereChar) ifFalse: [^self expected: 'NmToken'].
	s := (String new: 16) writeStream.
	s nextPut: hereChar.
	[self getNextChar.
	self isValidNameChar: hereChar] whileTrue: [s nextPut: hereChar].
	^s contents! !

!VWXMLXMLParser methodsFor: 'private'!
notPermitted: string

	self malformed: string, ' is not permitted'! !

!VWXMLXMLParser methodsFor: 'private'!
warn: aString
	"Modfied to unify warn system for SAX, REW"
	^self class warn: aString! !

!VWXMLXMLParser methodsFor: 'private'!
with: list add: node

	node isDiscarded
		ifFalse: [list add: node]! !

!VWXMLXMLParser methodsFor: 'streaming'!
atEnd

	[sourceStack == nil ifTrue: [^true].
	sourceStack atEnd]
		whileTrue:
			[sourceStack close.
			sourceStack := sourceStack nextLink].
	^false! !

!VWXMLXMLParser methodsFor: 'streaming'!
forceSpace

	self skipSpace ifFalse: [self expected: 'white space'].! !

!VWXMLXMLParser methodsFor: 'streaming'!
forceSpaceInDTD

	self skipSpaceInDTD ifFalse: [self expected: 'white space'].! !

!VWXMLXMLParser methodsFor: 'streaming'!
getNextChar

	^hereChar := self nextChar! !

!VWXMLXMLParser methodsFor: 'streaming'!
mustFind: str

	(self skipIf: str)
		ifFalse: [self expected: '"', str, '"']! !

!VWXMLXMLParser methodsFor: 'streaming'!
nextChar

	| ch |
	self atEnd.
	sourceStack == nil ifTrue: [^nil].
	lastSource := currentSource.
	currentSource := sourceStack.
	ch := currentSource nextFor: self.
	^ch! !

!VWXMLXMLParser methodsFor: 'streaming'!
skipIf: str

	| p oc |
	hereChar = str first ifFalse: [^false].
	p := self sourceWrapper stream position.
	oc := hereChar.
	1 to: str size do: [:i |
		hereChar = (str at: i)
			ifFalse:
				[self sourceWrapper stream position: p.
				hereChar := oc.
				^false].
		lastSource := currentSource.
		currentSource := self sourceWrapper.
		hereChar := self sourceWrapper nextFor: self].
	hereChar == nil
		ifTrue: [self getNextChar].
	^true! !

!VWXMLXMLParser methodsFor: 'streaming'!
skipSpace

	| n |
	n := 0.
	[hereChar ~~ nil and: [#(9 10 13 32) includes: hereChar asInteger]] whileTrue:
		[n := n+1.
		self getNextChar].
	^n > 0! !

!VWXMLXMLParser methodsFor: 'streaming'!
skipSpaceInDTD

	| space |
	space := self skipSpace.
	[self PERef: #dtd]
		whileTrue: [space := self skipSpace | space].
	^space! !

!VWXMLXMLParser methodsFor: 'streaming'!
upTo: aCharacter
	"Answer a subcollection from position to the occurrence (if any, exclusive) of anObject.
	 The stream is left positioned after anObject.
	If anObject is not found answer everything."

	| newStream element |
	newStream := (String new: 64) writeStream.
	[self atEnd]
		whileFalse:
			[element := self nextChar.
			element = aCharacter
				ifTrue: [^newStream contents].
			newStream nextPut: element.].
	self expected: (String with: aCharacter).
	^newStream contents! !

!VWXMLXMLParser methodsFor: 'streaming'!
upToAll: target
	" Answer a subcollection from the current position
	up to the occurrence (if any, not inclusive) of target,
	and leave the stream positioned before the occurrence.
	If no occurrence is found, answer the entire remaining
	stream contents, and leave the stream positioned at the end.
	We are going to cheat here, and assume that the first
	character in the target only occurs once in the target, so
	that we don't have to backtrack."

	| str i |
	(target occurrencesOf: target first) = 1
		ifFalse: [self error: 'The target collection is ambiguous.'].
	self sourceWrapper skip: -1.
	str := (String new: 32) writeStream.
	[str nextPutAll: (self upTo: target first).
	i := 2.
	[i <= target size and:
			[self nextChar = (target at: i)]]
		whileTrue:
			[i := i+1].
	i <= target size]
		whileTrue:
			[str nextPutAll: (target copyFrom: 1 to: i-1).
			self sourceWrapper skip: -1].
	self getNextChar.
	^str contents! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
conditionalSect

	| nm oldIgnore |
	hereChar = $< ifFalse: [^false].
	self inInternalSubset ifTrue: [^false].
	^(self skipIf: '<!![')
		ifTrue:
			[self skipSpaceInDTD.
			nm := self getSimpleName.
			(#('INCLUDE' 'IGNORE') includes: nm)
				ifFalse: [self expected: 'INCLUDE or IGNORE'].
			oldIgnore := ignore.
			ignore := ignore or: [nm = 'IGNORE'].
			self skipSpaceInDTD.
			self mustFind: '['.
			[self skipIf: ']]>']
				whileFalse: [self dtdEntry].
			ignore := oldIgnore.
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
dtdEntry

	((self PERef: #dtdEntry) or:
			[self markUpDecl or:
			[self conditionalSect or:
			[self skipSpace]]])
		ifFalse: [self expected: 'markup declaration or PE reference']! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
dtdFile: newURI

	| uri str |

	self documentNode noteExternalDTD.
	currentSource skip: -1.
		"So we don't lose hereChar."
	uri := VWXMLURIResolver resolve: newURI last from: self latestURI.
	self pushSource: (str := VWXMLStreamWrapper
						stream: (VWXMLURIResolver openStreamOn: uri)
						protocol: uri key
						name: uri value
						entity: nil).
	str usedAsExternal: true.
	str textDeclIn: self.
	self getNextChar.
	[self fullSourceStack includes: str]
		whileTrue: [self dtdEntry].! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
externalID: usage
	"Usage may be #docType, #entity, or #notation.
	DocType is treated specially, since PE references are not allowed.
	Notation is treated specially since the system identifier of the
		PUBLIC form is optional."

	| lit2 lit1 forceSpace skipSpace |
	forceSpace := [usage == #docType
					ifTrue: [self forceSpace]
					ifFalse: [self forceSpaceInDTD]].
	skipSpace := [usage == #docType
					ifTrue: [self skipSpace]
					ifFalse: [self skipSpaceInDTD]].
	^(self skipIf: 'SYSTEM')
		ifTrue:
			[forceSpace value.
			lit2 := self systemLiteral.
			Array with: lit2]
		ifFalse: [(self skipIf: 'PUBLIC')
			ifTrue:
				[forceSpace value.
				lit1 := self pubIdLiteral.
				usage == #notation
					ifTrue:
						[(skipSpace value and:
								[hereChar = $' or: [hereChar = $"]])
							ifTrue: [lit2 := self systemLiteral]
							ifFalse: [lit2 := nil]]
					ifFalse:
						[forceSpace value.
						lit2 := self systemLiteral].
				Array with: lit1 with: lit2]
			ifFalse:
				[nil]]! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
inInternalSubset

	self fullSourceStack reverseDo:
		[:str |
		str usedAsExternal == nil
			ifFalse: [^str usedAsExternal not]].
	self error: 'Not currently processing the DTD'! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
markUpDecl

	^self elementDecl
		or: [self attListDecl
		or: [self entityDecl
		or: [self notationDecl
		or: [self pi
		or: [self comment]]]]]! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
notationDecl

	| nm id str |
	str := currentSource.
	^(self skipIf: '<!!NOTATION')
		ifTrue:
			[self forceSpaceInDTD.
			nm := self getSimpleName.
			self forceSpaceInDTD.
			id := self externalID: #notation.
			ignore ifFalse: [dtd notationAt: nm put: (builder notation: nm value: id)].
			self skipSpaceInDTD.
			self mustFind: '>'.
			str == lastSource
				ifFalse: [self invalid: 'Improper nesting of declarations within a parameter entity'].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'DTD processing' stamp: 'BJP 7/25/2000 19:21'!
pubIdLiteral
	| str |
	str _ self quotedString.
	str
		do: [:ch | ((' -''()+,./:=?;!!*#@$_%' includes: ch)
					or: [ch asInteger = 10
							or: [ch asInteger = 13
									or: [ch asInteger < 127
											and: [ch isLetter
													or: [ch isDigit]]]]])
				ifFalse: [self expected: 'valid public id character']].
	^ str! !

!VWXMLXMLParser methodsFor: 'DTD processing'!
systemLiteral

	^self quotedString! !

!VWXMLXMLParser methodsFor: 'IDs'!
checkUnresolvedIDREFs

	(self isValidating and: [unresolvedIDREFs isEmpty not])
		ifTrue: [self invalid: ('The IDREFs <1p> have not been resolved to IDs' expandMacrosWith: unresolvedIDREFs asSortedCollection asArray)]! !

!VWXMLXMLParser methodsFor: 'IDs'!
rememberIDREF: anID

	self documentNode atID: anID ifAbsent: [unresolvedIDREFs add: anID]! !

!VWXMLXMLParser methodsFor: 'IDs'!
resolveIDREF: anID

	unresolvedIDREFs remove: anID ifAbsent: []! !

!VWXMLXMLParser methodsFor: 'accessing'!
dtd

	^dtd! !

!VWXMLXMLParser methodsFor: 'accessing'!
eol

	^eol! !

!VWXMLXMLParser methodsFor: 'accessing' stamp: 'BJP 7/19/2000 23:19'!
sourceWrapper
	self flag: #Question.
	^sourceStack "last"! !

!VWXMLXMLParser methodsFor: 'accessing'!
validate: aBoolean

	validating := aBoolean! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
attValue

	| data aQuote otherQuote s str1 |
	aQuote := hereChar.
	(aQuote = $' or: [aQuote = $"]) ifFalse: [^nil].
	otherQuote := aQuote = $'				"Added REW"
			ifTrue:[$"]
			ifFalse:[$'].
	s := currentSource.
	self getNextChar.
	data := (String new: 32) writeStream.
	OrderedCollection new.
	[(hereChar = aQuote and: [s = currentSource])]
		whileFalse:
			[hereChar = $<
				ifTrue: [self malformed: '< not permitted in attribute values; use &lt;'].
			hereChar = otherQuote 			"Added REW"
				ifTrue:[self invalid: 'Quote types must match in attribute values'].
			hereChar = $&
				ifTrue:
					[str1 := currentSource.
					(self skipIf: '&#')
						ifTrue: [self charEntity: data startedIn: str1]
						ifFalse: [self getNextChar; generalEntityInText: data canBeExternal: false]]
				ifFalse:
					[hereChar asInteger < 16r20
						ifTrue: [data space]
						ifFalse: [data nextPut: hereChar].
					self getNextChar]].
	self getNextChar.
	^data contents! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
attribute

	| nm value |
	nm := self getQualifiedName.
	self skipSpace.
	self mustFind: '='.
	self skipSpace.
	value := self attValue.
	value == nil ifTrue: [self expected: 'quoted value for the attribute'].
	^builder attribute: nm value: value! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
isValidName: aTag

	aTag size = 0 ifTrue: [^false].
	(self isValidNameStart: aTag first)
		ifFalse: [^false].
	2 to: aTag size do: [:i |
		(self isValidNameChar: (aTag at: i))
			ifFalse: [^false]].
	^true! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
isValidNmToken: aTag

	aTag size = 0 ifTrue: [^false].
	1 to: aTag size do: [:i |
		(self isValidNameChar: (aTag at: i))
			ifFalse: [^false]].
	^true! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
processAttributes

	| attributes |
	attributes := nil.
	[self skipSpace.
	self isValidNameStart: hereChar]
		whileTrue:
			[attributes == nil ifTrue: [attributes := OrderedCollection new].
			attributes add: self attribute.
			(attributes collect: [:i | i key]) asSet size = attributes size
				ifFalse: [self notPermitted: 'two attributes with the same name']].
	attributes := builder resolveNamespaces: attributes.
	^attributes! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
quotedString

	| string |
	hereChar = $"
		ifTrue:
			[string := self upTo: $".
			self getNextChar.
			^string].
	hereChar = $'
		ifTrue:
			[string := self upTo: $'.
			self getNextChar.
			^string].
	self expected: 'quoted string'! !

!VWXMLXMLParser methodsFor: 'attribute processing'!
validateAttributes: attributes for: tag

	| attr attributeList keys |

	attr := self dtd attributesFor: tag.
	attributeList := attributes == nil ifTrue: [#()] ifFalse: [attributes].
	keys := Set new.
	attributeList do: [:i |
		(keys includes: i key)
			ifTrue: [self malformed: ('the attribute <1s> was used twice in this element''s tag'
								expandMacrosWith: i key)]
			ifFalse: [keys add: i key].
		(attr includesKey: i key asString)
			ifFalse: [self invalid: ('the attribute <1s> was not defined in the DTD'
								expandMacrosWith: i key)]].

	attr do: [:adef | | a |
		a := attributeList detect: [:at | at key isLike: adef name] ifNone: [].
		a == nil
			ifTrue: [adef hasDefault
				ifTrue: [attributeList := attributeList copyWith:
							(builder attribute: adef name value: adef default)]
				ifFalse: [adef isRequired
					ifTrue: [self invalid: ('"<1s>" elements are required to have a "<2s>" attribute'
									expandMacrosWith: tag asString
									with: adef name asString)]]]
			ifFalse: [adef validateValueOf: a for: self]].
	^attributeList size = 0
		ifTrue: [nil]
		ifFalse: [attributeList]! !

!VWXMLXMLParser methodsFor: 'element processing'!
charEntity: data startedIn: str1

	| base digit n d |
	hereChar = $x
		ifTrue:
			[base := 16.
			digit := 'hex digit'.
			self getNextChar]
		ifFalse:
			[base := 10.
			digit := 'digit'].
	n := 0.
	[hereChar = $;]
		whileFalse:
			[d := hereChar digitValue.
			(d >= 0 and: [d < base]) ifFalse: [self expected: digit].
			n := n * base + d.
			self getNextChar].
	str1 = currentSource
		ifFalse: [self expected: 'proper nesting of character entities inside other entities'].
	(n >= 16r110000   "IllegalCharacters size"
			or: [(IllegalCharacters at: n+1) = 1])
		ifTrue: [self notPermitted: 'a character with Unicode value ', n printString].
	data nextPut: (Character value: n).
	self getNextChar! !

!VWXMLXMLParser methodsFor: 'element processing'!
closeTag: tag return: elements

	| nm |
	nm := self getQualifiedName.
	nm := builder correctTag: nm.
	self skipSpace.
	self mustFind: '>'.
	nm = tag
		ifFalse: [self expected: 'close tag for ', tag asString].
	^elements! !

!VWXMLXMLParser methodsFor: 'element processing'!
completeCDATA: str1

	| str data |
	data := (String new: 32) writeStream.
	[str := self upToAll: ']>'.
	str last = $]]
		whileFalse:
			[data nextPutAll: str; nextPutAll: ']>'].
	lastSource = str1
		ifFalse: [self expected: 'proper nesting of CDATA in entities'].
	data nextPutAll: (str copyFrom: 1 to: str size-1).
	^builder makeText: data contents! !

!VWXMLXMLParser methodsFor: 'element processing'!
completeComment: str1

	| str data comment |
	data := (String new: 32) writeStream.
	[str := self upToAll: '->'.
	str last = $-]
		whileFalse:
			[data nextPutAll: str; nextPutAll: '->'].
	data nextPutAll: (str copyFrom: 1 to: str size-1).
	comment := builder comment: data contents.
	(comment text findString: '--' startingAt: 1) = 0
		ifFalse: [self notPermitted: 'doubled hyphens in comments'].
	(comment text size > 0 and: [comment text last = $-])
		ifTrue: [self notPermitted: 'a hyphen as the last character in a comment'].
	lastSource = str1
		ifFalse: [self expected: 'proper nesting of comments in entities'].
	^comment! !

!VWXMLXMLParser methodsFor: 'element processing'!
completePI: str1

	| nm pi |
	nm := self getSimpleName.
	nm = 'xml' ifTrue: [self notPermitted: '"xml" declaration, except at the beginning of the file'].
	nm asLowercase = 'xml' ifTrue: [self notPermitted: '''xml'' as part of a name'].
	self skipSpace
		ifTrue:
			[pi := self upToAll: '?>']
		ifFalse:
			[pi := ''.
			self mustFind: '?>'].
	lastSource = str1
		ifFalse: [self expected: 'proper nesting of programming instructions in entities'].
	^builder pi: nm text: pi! !

!VWXMLXMLParser methodsFor: 'element processing'!
element

	| str1 startPosition |
	str1 := currentSource.
	startPosition := str1 stream position - (str1 characterSize: hereChar).
	^self elementAtPosition: startPosition! !

!VWXMLXMLParser methodsFor: 'element processing'!
elementAtPosition: startPosition

	| attributes nm str1 elements p tag |
	str1 := currentSource.
	self mustFind: '<'.
	nm := self getQualifiedName.
	^builder pushTag: nm
		whileDoing:
			[attributes := self processAttributes.
			self isValidating
				ifTrue: [attributes := self validateAttributes: attributes for: builder currentTag].
			(self skipIf: '/>')
				ifTrue: 
					[str1 = lastSource ifFalse: [self expected: 'elements properly nested within entities'].
					self isValidating
						ifTrue:
							[tag := builder currentTag.
							p := self dtd elementFor: tag.
							p == nil
								ifTrue: [self notPermitted: ('Using a tag (<1s>) without declaring it' expandMacrosWith: tag asString)]
								ifFalse: [p validateTag: tag content: #() for: self]].
					builder postProcessElement: (builder
						tag: builder currentTag
						attributes: attributes
						elements: nil
						position: startPosition
						stream: str1)]
				ifFalse: [(self skipIf: '>')
					ifTrue: 
						[str1 = lastSource ifFalse: [self expected: 'elements properly nested within entities'].
						elements := self elementContent: builder currentTag openedIn: str1.
						builder postProcessElement: (builder
							tag: builder currentTag
							attributes: attributes
							elements: elements
							position: startPosition
							stream: str1)]
					ifFalse: [self expected: 'end of start tag']]]! !

!VWXMLXMLParser methodsFor: 'element processing' stamp: 'BJP 7/20/2000 01:14'!
elementContent: tag openedIn: str

	| data elements str1 result p |
	data := (String new: 32) writeStream.
	elements := OrderedCollection new.
	[hereChar == nil
		ifTrue: [self expected: ('end tag for %<<1s>>' expandMacrosWith: tag)].
	hereChar = $<
		ifTrue:
			[data position = 0
				ifFalse:
					[data := data contents.
"					(data findString: ']]>' startingAt: 1) = 0
						ifFalse: [self halt: 'including ]]> in element content'].
"					self with: elements add: (builder makeText: data).
					data := (String new: 32) writeStream].
			str1 := currentSource.
			(self skipIf: '</')
				ifTrue:
					[result := self closeTag: tag return: elements asArray.
					str == lastSource
						ifFalse: [self expected: 'elements properly nested within entities'].
					self isValidating
						ifTrue:
							[p := self dtd elementFor: tag.
							p == nil
								ifTrue: [self invalid: ('Using a tag (<1s>) without declaring it is not valid' expandMacrosWith: tag)]
								ifFalse: [p validateTag: tag content: result for: self]].
					^result]
				ifFalse: [(self skipIf: '<?')
					ifTrue: [self with: elements add: (self completePI: str1)]
					ifFalse: [ (self skipIf: '<!![CDATA[')
						ifTrue: [self with: elements add: (self completeCDATA: str1)]
						ifFalse: [(self skipIf: '<!!--')
							ifTrue: [self with: elements add: (self completeComment: str1)]
							ifFalse: [self with: elements add: self element]]]]]
		ifFalse: [hereChar = $&
			ifTrue:
				[str1 := currentSource.
				(self skipIf: '&#')
					ifTrue: [self charEntity: data startedIn: str1]
					ifFalse: [self getNextChar; generalEntityInText: data canBeExternal: true]]
			ifFalse:
				[data nextPut: hereChar.
				self getNextChar]]] repeat! !

!VWXMLXMLParser methodsFor: 'element processing'!
generalEntityInText: str canBeExternal: external

	| exp nm str1 |

	str1 := lastSource.
	nm := self getSimpleName.
	hereChar = $;
		ifFalse: [self expected: 'semicolon'].
	currentSource = str1
		ifFalse: [self expected: 'proper nesting of entity references within other entity references'].
	exp := self dtd generalEntityAt: nm.
	exp == nil
		ifTrue: [self warn: ('The general entity "<1s>" has not been defined'
							expandMacrosWith: nm)].
	exp == nil
		ifTrue:
			[self shouldTestWFCEntityDeclared
				ifTrue: [self malformed: 'General entity used but not defined'].
			str nextPut: $&; nextPutAll: nm; nextPut: $;.
			self getNextChar]
		ifFalse:
			[(external or: [exp isExternal not])
				ifFalse: [self notPermitted: 'external entities in attribute values'].
			exp isParsed
				ifFalse: [self malformed: 'References to unparsed entities other than in an attribute of type ENTITY are not permitted'].
			exp streamFor: self].! !

!VWXMLXMLParser methodsFor: 'element processing'!
isValidTag: aTag

	^true! !

!VWXMLXMLParser methodsFor: 'attribute def processing'!
attListDecl

	| nm str1 attr |
	str1 := currentSource.
	^(self skipIf: '<!!ATTLIST')
		ifTrue:
			[self forceSpaceInDTD.
			nm := self getQualifiedName.
			[self skipSpaceInDTD.
			self skipIf: '>']
				whileFalse:
					[self skipSpaceInDTD.
					attr := VWXMLAttributeDef new name: self getQualifiedName.
					self forceSpaceInDTD.
					attr type: self attType.
					self forceSpaceInDTD.
					attr default: self defaultDecl.
					self isValidating ifTrue: [attr selfValidateFor: self].
					ignore ifFalse: [self dtd attributeFor: nm subKey: attr name put: attr]].
			str1 == lastSource
				ifFalse: [self invalid: 'Improper nesting of declarations within a parameter entity'].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'attribute def processing' stamp: 'BJP 7/19/2000 23:34'!
attType

	| nm all type |
self flag: #PortIssue.
	^hereChar = $(
		ifTrue: [self enumeration]
		ifFalse:
			[nm := self getSimpleName.
			all := #('NOTATION' 'CDATA' 'ID'
						'IDREF' 'IDREFS'
						'ENTITY' 'ENTITIES'
						'NMTOKEN' 'NMTOKENS').
			(all includes: nm)
				ifFalse: [self expected: 'one of ', all storeString].
			type := Smalltalk at:  (#(#VWXMLNOTATIONat #VWXMLCDATAat #VWXMLIDat
						#VWXMLIDREFat #VWXMLIDREFSat
						#VWXMLENTITYat #VWXMLENTITIESat
						#VWXMLNMTOKENat #VWXMLNMTOKENSat)
					at: (all indexOf: nm)).
			nm = 'NOTATION'
				ifTrue: [self completeNotationType]
				ifFalse: [type new]].! !

!VWXMLXMLParser methodsFor: 'attribute def processing'!
completeNotationType

	| nm |
	self forceSpaceInDTD.
	self mustFind: '('.
	self skipSpaceInDTD.
	nm := OrderedCollection with: self getSimpleName.
	self skipSpaceInDTD.
	[self skipIf: '|']
		whileTrue:
			[self skipSpaceInDTD.
			nm add: self getSimpleName.
			self skipSpaceInDTD].
	self mustFind: ')'.
	^VWXMLNOTATIONat typeNames: nm! !

!VWXMLXMLParser methodsFor: 'attribute def processing'!
defaultDecl

	| fixed default |
	^(self skipIf: '#REQUIRED')
		ifTrue: [#required]
		ifFalse: [(self skipIf: '#IMPLIED')
			ifTrue: [#implied]
			ifFalse:
				[fixed := self skipIf: '#FIXED'.
				fixed ifTrue:
					[self forceSpaceInDTD].
				default := self attValue.
				default == nil ifTrue: [self expected: 'quoted value for the attribute''s default'].
				fixed -> default]]! !

!VWXMLXMLParser methodsFor: 'attribute def processing'!
enumeration

	| nm |
	self mustFind: '('.
	self skipSpaceInDTD.
	nm := OrderedCollection with: self nmToken.
	self skipSpaceInDTD.
	[self skipIf: '|']
		whileTrue:
			[self skipSpaceInDTD.
			nm add: self nmToken.
			self skipSpaceInDTD].
	self mustFind: ')'.
	^VWXMLENUMERATIONat withAll: nm! !

!VWXMLXMLParser methodsFor: 'attribute def processing'!
latestURI

	| s nm |
self flag: #PortIssue.
	s := self fullSourceStack reverse detect: [:i | i protocol ~= 'internal'] ifNone: [nil].
	^s == nil
		ifTrue:
			[nm := FileDirectory default pathName, FileDirectory slash, 'xxx'. "#changed-umejava"
	"nm := (Filename defaultDirectory construct: 'xxx') asString."
			nm replaceAll: Filename separator with: $/.
"Filename is VisualWorks specific. FileDirectory"
			'file' -> nm]
		ifFalse: [s protocol -> s name]! !

!VWXMLXMLParser methodsFor: 'entity processing'!
PERef: refType

	| nm exp |
	^(hereChar = $%)
		ifTrue:
			[self getNextChar.
			(self inInternalSubset and: [refType ~= #dtdEntry])
				ifTrue: [self notPermitted: 'Parameter entity reference in the internal DTD, inside a declaration'].
			nm := self getSimpleName.
			hereChar = $; ifFalse: [self expected: 'semicolon'].
			exp := self dtd parameterEntityAt: nm.
			exp == nil
				ifTrue: [self warn: ('The parameter entity "<1s>" has not been defined'
							expandMacrosWith: nm)].
			exp == nil
				ifTrue: [self isValidating
					ifTrue:
						[self invalid: 'Parameter entity used but not defined'.
						self getNextChar]
					ifFalse:
						[self pushSource: (VWXMLStreamWrapper
								emptyWithExtraSpace: refType ~= #data).
						self getNextChar]]
				ifFalse:
					[exp streamFor: self addSpaces: refType ~= #data].
			(refType ~= #data and: [self sourceWrapper protocol ~= 'internal'])
				ifTrue: [self sourceWrapper usedAsExternal: true].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'entity processing'!
entityDecl

	| nm def str |
	str := currentSource.
	^(self skipIf: '<!!ENTITY')
		ifTrue:
			[self forceSpace.
			hereChar = $%
				ifTrue:
					[self getNextChar; forceSpaceInDTD.
					nm := self getSimpleName.
					self forceSpaceInDTD.
					def := self peDef: nm. 		"peDef modified for SAX. REW"
					ignore ifFalse: [self dtd parameterEntityAt: nm put: def]]
				ifFalse:
					[self skipSpaceInDTD.
					nm := self getSimpleName.
					self forceSpaceInDTD.
					def := self entityDef: nm.	"entityDef modified for SAX. REW"
					ignore ifFalse: [self dtd generalEntityAt: nm put: def]].
			self skipSpaceInDTD.
			self mustFind: '>'.
			str == lastSource
				ifFalse: [self invalid: 'Improper nesting of declarations within a parameter entity'].
			true]
		ifFalse: [false]! !

!VWXMLXMLParser methodsFor: 'entity processing'!
entityDef: entityName
	"Parameter entityName added for SAX. REW" 
	| val ndata |
	^(val := self entityValue) == nil 
		ifTrue: 
			[(val := self externalID: #entity) == nil 
				ifTrue: [self expected: 'entity value or external id']
				ifFalse: 
					[ndata := self nDataDecl.
					builder 
						externalGeneralEntity: entityName
						id: val
						ndata: ndata
						uri: self latestURI]]
		ifFalse: [builder internalGeneralEntity: entityName value: val]! !

!VWXMLXMLParser methodsFor: 'entity processing'!
entityValue

	| data aQuote s str1 |
	aQuote := hereChar.
	(aQuote = $' or: [aQuote = $"]) ifFalse: [^nil].
	s := currentSource.
	self getNextChar.
	data := (String new: 32) writeStream.
	OrderedCollection new.
	[hereChar == nil
		ifTrue: [self expected: (String with: aQuote)].
	(hereChar = aQuote and: [s = currentSource])]
		whileFalse:
			[hereChar = $&
				ifTrue:
					[str1 := currentSource.
					(self skipIf: '&#')
						ifTrue: [self charEntity: data startedIn: str1]
						ifFalse: [self getNextChar; generalEntity: data]]
				ifFalse: [(self PERef: #data)
					ifFalse:
						[data nextPut: hereChar.
						self getNextChar]]].
	self getNextChar.
	^data contents! !

!VWXMLXMLParser methodsFor: 'entity processing'!
generalEntity: str

	| nm |
	nm := self getSimpleName.
	hereChar = $;
		ifFalse: [self expected: 'semicolon'].
	str nextPut: $&; nextPutAll: nm; nextPut: $;.
	self getNextChar! !

!VWXMLXMLParser methodsFor: 'entity processing'!
nDataDecl

	^self skipSpaceInDTD
		ifTrue: [(self skipIf: 'NDATA')
			ifTrue:
				[self forceSpaceInDTD.
				self getSimpleName]
			ifFalse: [nil]]
		ifFalse: [nil]! !

!VWXMLXMLParser methodsFor: 'entity processing'!
peDef: entityName
	"Parameter entityName added for SAX. REW" 
	| val |
	^(val := self entityValue) == nil
		ifTrue: [(val := self externalID: #entity) == nil
			ifTrue: [self expected: 'entity value or external id']
			ifFalse:
				[builder
					externalParameterEntity: entityName 
					id: val]]
		ifFalse: 
			[builder
				internalParameterEntity: entityName 
				value: val]! !

!VWXMLXMLParser methodsFor: 'element def processing'!
completeChildren: str

	| div items node |
	items := OrderedCollection with: self cp. 
	self skipSpaceInDTD.
	div := nil.
	[self skipIf: ')']
		whileFalse:
			[div == nil ifTrue:
				[(',|' includes: hereChar) ifFalse: [self expected: ', or |'].
				div := hereChar].
			div = hereChar ifFalse: [self expected: (String with: div)].
			self getNextChar; skipSpaceInDTD.
			items add: self cp.
			self skipSpaceInDTD].
	(self isValidating and: [lastSource ~~ str])
		ifTrue: [self expected: 'proper nesting of parentheses within entities'].
	div == nil ifTrue: [div := $,].
	div = $,
		ifTrue: [node := VWXMLSequencePattern on: items]
		ifFalse: [node := VWXMLChoicePattern on: items].
	('*+?' includes: hereChar)
		ifTrue:
			[node := VWXMLModifiedPattern on: node type: hereChar.
			self getNextChar].
	^node! !

!VWXMLXMLParser methodsFor: 'element def processing'!
completeMixedContent: str

	"we already have the #PCDATA finished."
	| names |
	self skipSpaceInDTD.
	names := OrderedCollection new.
	[hereChar = $)]
		whileFalse:
			[self mustFind: '|'.
			self skipSpaceInDTD.
			names add: (VWXMLNamePattern named: self getQualifiedName).
			self skipSpaceInDTD].
	(self isValidating and: [currentSource ~~ str])
		ifTrue: [self expected: 'proper nesting of parentheses within entities'].
	names size = 0
		ifTrue: 
			[self mustFind: ')'.
			self skipIf: '*']			"(#PCDATA) and (#PCDATA)* are legal. REW"
		ifFalse: [self mustFind: ')*'].
	^VWXMLMixedPattern on: names! !

!VWXMLXMLParser methodsFor: 'element def processing'!
contentsSpec

	| str |
	^(self skipIf: 'ANY')
		ifTrue: [VWXMLAnyPattern new]
		ifFalse: [(self skipIf: 'EMPTY')
			ifTrue: [VWXMLEmptyPattern new]
			ifFalse:
				[str := currentSource.
				self mustFind: '('.
				self skipSpaceInDTD.
				(self skipIf: '#PCDATA')
					ifTrue: [self completeMixedContent: str]
					ifFalse: [self completeChildren: str]]]! !

!VWXMLXMLParser methodsFor: 'element def processing'!
cp

	| node str |
	str := currentSource.
	^(self skipIf: '(')
		ifTrue: [self completeChildren: str]
		ifFalse:
			[hereChar = $% ifTrue: [self PERef: #data]. "Added REW"
			node := VWXMLNamePattern named: self getQualifiedName.
			('*+?' includes: hereChar)
				ifTrue:
					[node := VWXMLModifiedPattern on: node type: hereChar.
					self getNextChar].
			node]! !

!VWXMLXMLParser methodsFor: 'element def processing' stamp: 'BJP 7/27/2000 14:56'!
elementDecl
	| nm cSpec str |

	str _ currentSource.
	^ (self skipIf: '<!!ELEMENT')
		and: [self forceSpaceInDTD.
			nm _ self getQualifiedName.
			self forceSpaceInDTD.
			cSpec _ self contentsSpec normalize.
			ignore
				ifFalse: [self dtd elementFor: nm put: cSpec].
			self skipSpaceInDTD.
			self mustFind: '>'.
			str == lastSource
				ifFalse: [self invalid: 'Improper nesting of declarations within a parameter entity'].
			true]! !

!VWXMLXMLParser methodsFor: 'element def processing'!
validateEncoding: encName

	| c |
	encName size = 0 ifTrue: [self expected: 'non-empty encoding name'].
	c := encName first.
	(c asInteger < 128 and: [c isLetter])
		ifFalse: [self malformed: ('The first letter of the encoding ("<1s>") must be an ASCII alphabetic letter'
						expandMacrosWith: encName)].
	2 to: encName size do: [:i |
		c := encName at: i.
		(c asInteger < 128 and: [c isLetter or: [c isDigit or: ['._-' includes: c]]])
			ifFalse: [self malformed: ('The first name of the encoding ("<1s>") must be ''.'', ''_'', ''-'', or an ASCII letter or digit'
						expandMacrosWith: encName)]]! !

!VWXMLXMLParser methodsFor: 'initialize'!
builder: anXMLNodeBuilder

	builder := anXMLNodeBuilder! !

!VWXMLXMLParser methodsFor: 'initialize'!
lineEndLF

	eol := Character lf! !

!VWXMLXMLParser methodsFor: 'initialize' stamp: 'BJP 7/19/2000 23:38'!
on: inputStream
self flag: #PortIssue.
"	[inputStream lineEndTransparent] on: Error do: [:ex | ]."
	validating == nil ifTrue: [validating := true].
	sourceStack := self wrapStream: inputStream.
	builder == nil
		ifTrue: [builder := VWXMLNodeBuilder new].
	documentNode := VWXMLDocument new.
	dtd := VWXMLDocumentType new.
	documentNode dtd: dtd.
	unresolvedIDREFs := Set new.
	ignore := false.
	eol := Character cr! !

!VWXMLXMLParser methodsFor: 'initialize' stamp: 'BJP 7/19/2000 23:53'!
wrapStream: aStream

	^VWXMLStreamWrapper
		stream: aStream
		protocol: ((aStream isKindOf: FileStream)
						ifTrue: ['file']
						ifFalse: ['internal'])
		name: nil
		entity: nil! !


!VWXMLXMLParser class methodsFor: 'utilities'!
error: aStringOrMessage

	^VWXMLXMLSignal raiseErrorString: aStringOrMessage asString! !

!VWXMLXMLParser class methodsFor: 'utilities'!
illegalCharacters
	^IllegalCharacters! !

!VWXMLXMLParser class methodsFor: 'utilities' stamp: 'BJP 7/20/2000 10:46'!
invalid: aString
	VWXMLInvalidSignal raiseSignal: aString! !

!VWXMLXMLParser class methodsFor: 'utilities'!
malformed: aString

	VWXMLMalformedSignal raiseSignal: aString! !

!VWXMLXMLParser class methodsFor: 'utilities' stamp: 'BJP 7/19/2000 17:32'!
mapEncoding: anEncoding

	| enc |
self flag: #PortIssue.
	enc := anEncoding asLowercase.
	enc = 'utf-8' ifTrue: [^'UTF_8'].
	enc = 'utf-16' ifTrue: [^'UTF_16'].
	enc = 'iso-8859-1' ifTrue: [^'ISO8859_1'].
	^enc! !

!VWXMLXMLParser class methodsFor: 'utilities' stamp: 'BJP 7/19/2000 17:32'!
readFileContents: fn

	| s p |
self flag: #PortIssue.
	s := VWXMLStreamWrapper
			stream: (fn withEncoding: #'UTF_8') readStream
			protocol: 'file'
			name: nil	
			entity: nil.
	p := self new.
	p lineEndLF.
	^[s checkEncoding.
	  s contentsFor: p]
		ensure: [s close]! !

!VWXMLXMLParser class methodsFor: 'utilities' stamp: 'BJP 7/20/2000 00:37'!
warn: aString
	"Added to unify warnings for SAX. REW"

	^VWXMLWarningSignal raiseSignal: aString! !

!VWXMLXMLParser class methodsFor: 'class initialization' stamp: 'BJP 7/19/2000 17:23'!
initialize
	"VWXMLXMLParser initialize"

	IllegalCharacters := WordArray new: 16r110000.

	((0 to: 16r1F) asSet remove: 9; remove: 10; remove: 13; yourself)
		do: [:i | IllegalCharacters at: i+1 put: 1].
	16rD800 to: 16rDFFF
		do: [:i | IllegalCharacters at: i+1 put: 1].
	16rFFFE to: 16rFFFF
		do: [:i | IllegalCharacters at: i+1 put: 1].
	"IllegalCharacters compress."! !

!VWXMLXMLParser class methodsFor: 'instance creation'!
on: aStream

	^self new on: aStream! !

!VWXMLXMLParser class methodsFor: 'instance creation'!
processDocumentInFilename: aFilename 

	^self processDocumentInFilename: aFilename beforeScanDo: [:parser | ]! !

!VWXMLXMLParser class methodsFor: 'instance creation' stamp: 'BJP 7/24/2000 23:13'!
processDocumentInFilename: aFilename beforeScanDo: aBlock 
	| stream p fname |
	self flag: #PortIssue.
	(aFilename isKindOf: FileStream)
		ifTrue: [fname _ aFilename fullName]
		ifFalse: [fname _ aFilename].
	"For compatibility with Roger's tests"
	stream _ "ReadStream
				on:" (CrLfFileStream readOnlyFileNamed: fname).
	"contentsOfEntireFile"
	"(aFilename asFilename withEncoding: #'UTF_8') readStream."
	"I *think* that if we just open a normal stream here, we should be ok.  
	This will screw us on documents that use non-ASCII but UTF_8  
	characters in the *prolog*. Otherwise, we can just set up the  
	mapEncoding thingy to boot us hard of other encodings."
	"stream lineEndTransparent."
	p _ self on: stream.
	aBlock value: p.
	^ p scanDocument! !

!VWXMLXMLParser class methodsFor: 'instance creation'!
processDocumentString: aString

	^self processDocumentString: aString beforeScanDo: [:parser | ]! !

!VWXMLXMLParser class methodsFor: 'instance creation'!
processDocumentString: aString beforeScanDo: aBlock

	| p |
	p := self on: aString readStream.
	aBlock value: p.
	^p scanDocument! !


!VWXMLXMLSignal class methodsFor: 'as yet unclassified'!
raiseErrorSignal: aString
	self signal: aString! !

!VWXMLXMLSignal class methodsFor: 'as yet unclassified'!
raiseErrorString: aString
	self signal: aString! !

!VWXMLXMLSignal class methodsFor: 'as yet unclassified'!
raiseSignal: aString
	self signal: aString! !


!VWXMLInvalidSignal class methodsFor: 'testing'!
mayResume

	^true! !


!VWXMLWarningSignal class methodsFor: 'as yet unclassified'!
raiseSignal: aString
	self signal: aString! !

VWXMLXMLParser initialize!

!VWXMLStreamWrapper reorganize!
('declaration' encodingDeclIn: expected: mustFind:errorOn: quotedString sdDeclIn: skipIf: skipSpaceIn: textDeclIn: versionInfoIn: xmlDeclIn:)
('streaming' nextFor: skip:)
('accessing' characterSize: checkEncoding close contentsFor: entity name protocol stream)
('initialize' stream:protocol:name:entity: usedAsExternal usedAsExternal:)
('testing' atEnd)
('private' error:)
!

VWXMLDocumentType initialize!
